
% Discretises, conjectures and approximates the match characteristics
% TECHNOLOGY

% Match characteristics

x_lb = logncdf(param.b_u,param.mu_x,param.sigma_x);



%% joint denisty of x and alpha

xs_grid = linspace(x_lb,1-aux.trim,aux.x_grid);
alphas_grid = linspace(0,1,aux.alpha_grid^2);

[xs_grid1,alphas_grid1] = meshgrid(xs_grid,alphas_grid);
x = xs_grid1(:);
alph = alphas_grid1(:);
f_large = copulapdf('Gaussian',[x,alph],param.corr); % joint density of x and alpha
f_large = (1-x_lb)*f_large./(sum(f_large)); 
clear alph xs_grid1 x x_lb

f_large = reshape(f_large,length(alphas_grid),aux.x_grid);
f_grid = zeros(aux.alpha_grid,aux.x_grid);
h_grid = betainv(alphas_grid1,param.beta1,param.beta2);

home_work = linspace(aux.trim,1,aux.alpha_grid); 
f_grid(1,:) = sum(f_large.*(h_grid<=aux.trim) );
for tt=2:aux.alpha_grid
    f_grid(tt,:) =  sum(f_large.*(h_grid>home_work(tt-1)).*(h_grid<=home_work(tt)) );
end
clear xs_grid2 h_grid f_large

[xs_grid2,hw] = meshgrid(xs_grid,home_work);
x = xs_grid2(:);
alph = betacdf(hw(:),param.beta1,param.beta2);
f = reshape(f_grid,aux.alpha_grid*aux.x_grid,1);
clear xs_grid tt xs_grid2 f_grid home_work hw alphas_grid alphas_grid1

%% production

xtil = exp(param.mu_x + param.sigma_x*norminv(x) ); 

home_work=betainv(alph,param.beta1,param.beta2);

if aux.lockdown==0
    p0 = home_work.*xtil;
else
    p0 = home_work.*xtil;
end

p1 = xtil;

if aux.furlough==1 && aux.lockdown==1 
    p2 =  (ss.S_s>=0).*( min(param.furlough_cap,xtil.*param.furlough) + param.b_u) +...  
          (ss.S_s <0).* 0;
end

%% state variables
if aux.steady_state==0
    us_grid = linspace(1e-6,aux.max_us,aux.us_grid); %there must be some unemployed or firm's wont post vacancies
    ur_grid = linspace(0,aux.max_ur,aux.ur_grid);
    li_grid = linspace(0,aux.max_li,aux.inf_grid);

    [us_grid1,ur_grid1,li_grid1] = meshgrid(us_grid,ur_grid,li_grid);
    u_s = us_grid1(:)';
    u_r = ur_grid1(:)';
    li = li_grid1(:)';

    us_grid_dyn = linspace(1e-6,aux.max_us + 1,aux.us_grid + 1); 
    ur_grid_dyn = linspace(0,aux.max_ur  + 1,aux.ur_grid  + 1);
    li_grid_dyn = linspace(0,aux.max_li + 1,aux.inf_grid + 1);

    [us_grid1_dyn,ur_grid1_dyn,li_grid1_dyn] = meshgrid(us_grid_dyn,ur_grid_dyn,li_grid_dyn);
    u_s_dyn = us_grid1_dyn(:)';
    u_r_dyn = ur_grid1_dyn(:)';
    li_dyn = li_grid1_dyn(:)';
        
    clear us_grid ur_grid us_grid1 ur_grid1 li_grid li_grid1
elseif aux.steady_state==1
   
    li = 0;
    u_s = 0.05;
    u_r= 0;   
end

state_length = length(li);

if aux.steady_state==1
    vac = 0.05*ones(1,state_length);
    tight = vac./(u_s+u_r);
elseif aux.steady_state==0 && aux.lockdown==0
    tight = ss.tight*ones(1,state_length);
elseif aux.steady_state==0 && aux.lockdown==1
    tight = ss_ld.tight*ones(1,state_length);
end
    

