
% Solves the ``recovered block'' fixed point problem and backs-out the
% remaining value functions
    
% Iteration variables
diff = 100;
iter = 0;

% INITIALISE THE SURPLUS FUNCTION
if aux.steady_state==1 && aux.lockdown==0
    S_r = zeros(aux.x_grid*aux.alpha_grid, state_length);
elseif aux.steady_state==0 && aux.lockdown==0 && iter_outer==1  
    S_r = repmat(ss.S_r,1, state_length);
elseif aux.steady_state==1 && aux.lockdown==1
    S_r_U = zeros(aux.x_grid*aux.alpha_grid, state_length);
    S_r_L = zeros(aux.x_grid*aux.alpha_grid, state_length);
    if aux.furlough==1
        S_r_U_2 = zeros(aux.x_grid*aux.alpha_grid, state_length);
        S_r_L_2 = zeros(aux.x_grid*aux.alpha_grid, state_length);
    end
elseif aux.steady_state==0 && aux.lockdown==1 && iter_outer==1  
    S_r_L    = repmat(ss_ld.S_r_L,1, state_length);
    S_r_U   = repmat(ss_ld.S_r_U,1, state_length);
    if aux.furlough==1
        S_r_U_2 = repmat(ss_ld.S_r_U_2,1, state_length);
        S_r_L_2 = repmat(ss_ld.S_r_L_2,1, state_length);
    end
end

%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
% SURPLUS FIXED POINT ITERATIONS
%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
if aux.steady_state==0
    nu = param.nu; 
elseif aux.steady_state==1
    nu=0;
end

    
if aux.lockdown==1 && aux.steady_state==1
    S_r = ss.S_r;            
elseif aux.lockdown==1 && aux.steady_state==0
    S_r = laissez.S_r;      
    
end


if aux.lockdown==0
    b_u=param.b_u;
    flow_ben  = repmat(p1 - param.b_u,1,state_length);
    flow_ben0 = repmat(p0 - param.b_u,1,state_length);  
else
    b_u=param.b_u;
    flow_ben  = repmat(p1 - b_u,1,state_length);
    flow_ben0 = repmat(p0 - b_u,1,state_length);
    
    if aux.furlough==1
        flow_ben2 = repmat(p2 - b_u,1,state_length); 
    end
    
end
    
    
while diff>aux.conv_diff
    

    if aux.lockdown==0

         S_r_new = ( ...
             flow_ben - ...
             param.beta*repmat(phi.*(f'*max(S_r,0)),aux.x_grid*aux.alpha_grid,1 )...
             + nu*max(S_r,0) )./ (param.r + param.delta + param.eta + nu); 
        
        
        diff = max(abs( reshape(S_r_new,aux.x_grid*aux.alpha_grid*state_length,1) - ...
            reshape(S_r,aux.x_grid*aux.alpha_grid*state_length,1) ) ./ ...
            abs(reshape(S_r,aux.x_grid*aux.alpha_grid*state_length,1)) );
        
        if iter<500
            S_r = S_r_new;
        elseif iter>499 
            S_r = 0.9*S_r + 0.1*S_r_new;
        end
        
    elseif aux.lockdown==1 


        S_r_U_new = ( ...
                flow_ben - ...
                param.beta*param.pi*repmat(phi.*(f'*max(S_r_L,0)),aux.x_grid*aux.alpha_grid,1 ) ...
                - param.beta*(1-param.pi)*repmat(phi.*(f'*max(S_r_U,0)),aux.x_grid*aux.alpha_grid,1 ) ... 
                + nu*max(S_r_U,0) + param.Lambda*S_r)./ (param.r + param.delta + param.eta + nu + param.Lambda);
        
      diff_U = max(abs( reshape(S_r_U_new,aux.x_grid*aux.alpha_grid*state_length,1) - ...
            reshape(S_r_U,aux.x_grid*aux.alpha_grid*state_length,1) ) ./ ...
            abs(reshape(S_r_U,aux.x_grid*aux.alpha_grid*state_length,1)) );
        
     if aux.furlough==1
        S_r_U_2_new = ( ...
            flow_ben2 ...
            - (param.beta*param.pi*repmat(phi,aux.x_grid*aux.alpha_grid,1).*sum( max(S_r_L,0).*repmat(f,1,state_length) )) ...
            - (param.beta*(1-param.pi)*repmat(phi,aux.x_grid*aux.alpha_grid,1).*sum( max(S_r_U,0).*repmat(f,1,state_length) )) ...  
            + nu*max(0,max(S_r_U,S_r_U_2)) + param.Lambda*S_r)./ (param.r + param.delta + param.eta + nu + param.Lambda);

        
        S_r_L_new = ( ...
            flow_ben0 - ...
            (param.beta*param.pi*repmat(phi,aux.x_grid*aux.alpha_grid,1).*sum( max(S_r_L,0).*repmat(f,1,state_length) )) ...
            - (param.beta*(1-param.pi)*repmat(phi,aux.x_grid*aux.alpha_grid,1).*sum( max(S_r_U,0).*repmat(f,1,state_length) )) ... 
            + nu*max(0,max(S_r_L,S_r_L_2)) + param.Lambda*S_r)./ (param.r + param.delta + param.eta + nu + param.Lambda);
        
        
        S_r_L_2_new = ( ...
            flow_ben2 - ...
            (param.beta*param.pi*repmat(phi,aux.x_grid*aux.alpha_grid,1).*sum( max(S_r_L,0).*repmat(f,1,state_length) )) ...
            - (param.beta*(1-param.pi)*repmat(phi,aux.x_grid*aux.alpha_grid,1).*sum( max(S_r_U,0).*repmat(f,1,state_length) )) ...  
            + nu*max(0,max(S_r_L,S_r_L_2)) + param.Lambda*S_r)./ (param.r + param.delta + param.eta + nu + param.Lambda);
        
        
        diff_U_2 = max(abs( reshape(S_r_U_2_new,aux.x_grid*aux.alpha_grid*state_length,1) - ...
            reshape(S_r_U_2,aux.x_grid*aux.alpha_grid*state_length,1) ) ./ ...
            abs(reshape(S_r_U_2,aux.x_grid*aux.alpha_grid*state_length,1)) );
        
        diff_L = max(abs( reshape(S_r_L_new,aux.x_grid*aux.alpha_grid*state_length,1) - ...
            reshape(S_r_L,aux.x_grid*aux.alpha_grid*state_length,1) ) ./ ...
            abs(reshape(S_r_L,aux.x_grid*aux.alpha_grid*state_length,1)) );
        
        diff_L_2 = max(abs( reshape(S_r_L_2_new,aux.x_grid*aux.alpha_grid*state_length,1) - ...
            reshape(S_r_L_2,aux.x_grid*aux.alpha_grid*state_length,1) ) ./ ...
            abs(reshape(S_r_L_2,aux.x_grid*aux.alpha_grid*state_length,1)) );
        
        diff = max([diff_L,diff_L_2, diff_U, diff_U_2]);
        
     elseif aux.furlough==0
         

        S_r_L_new = ( ...
                flow_ben0 - ...
                param.beta*param.pi*repmat(phi.*(f'*max(S_r_L,0)),aux.x_grid*aux.alpha_grid,1 ) ...
                - param.beta*(1-param.pi)*repmat(phi.*(f'*max(S_r_U,0)),aux.x_grid*aux.alpha_grid,1 ) ...  
                + nu*max(0,S_r_L) + param.Lambda*S_r)./ (param.r + param.delta + param.eta + nu + param.Lambda);
        
      diff_L = max(abs( reshape(S_r_L_new,aux.x_grid*aux.alpha_grid*state_length,1) - ...
            reshape(S_r_L,aux.x_grid*aux.alpha_grid*state_length,1) ) ./ ...
            abs(reshape(S_r_L,aux.x_grid*aux.alpha_grid*state_length,1)) );
        
      diff = max([diff_L, diff_U]);
     end
     
     

        if iter<500
            S_r_L = S_r_L_new;
            S_r_U = S_r_U_new;
            
            if aux.furlough==1
                S_r_L_2 = S_r_L_2_new;
                S_r_U_2 = S_r_U_2_new;
            end
        else
            S_r_L = 0.9*S_r_L + 0.1*S_r_L_new;
            S_r_U = 0.9*S_r_U + 0.1*S_r_U_new;
            
            if aux.furlough==1
                S_r_L_2 = 0.9*S_r_L_2 + 0.1*S_r_L_2_new;
                S_r_U_2 = 0.9*S_r_U_2 + 0.1*S_r_U_2_new;
            end
        end
        
    end
    iter=iter+1;
    

    
end

clear flow_ben flow_ben0

if aux.steady_state==0 
    U_r = ( param.b_u + param.beta*phi.*sum( max(S_r,0).*repmat(f,1,state_length) ) + param.eta*R_r )./ ...
            (param.r + param.eta);
end
if aux.steady_state==0 && aux.lockdown==1
   
    U_r_L = ( param.b_u ...
        + param.beta*    param.pi*phi.*sum(max(S_r_L,0).*repmat(f,1,state_length) ) ...
        + param.beta*(1-param.pi)*phi.*sum(max(S_r_U,0).*repmat(f,1,state_length) ) ...
        + param.eta*R_r + param.Lambda*U_r)./ (param.r + param.eta + param.Lambda);
end


