
% Solves the ``infected block'' and backs-out the remaining value functions
    
% Iteration variables
diff = 100;

% The death rate
gamma_y_min = param.gamma_y*max(li./param.Theta, 1);

% INITIALISE THE SURPLUS FUNCTION
if aux.steady_state==1 && aux.lockdown==0
    S_i = zeros(aux.x_grid*aux.alpha_grid, state_length);
elseif aux.steady_state==0 && iter_outer==1 && aux.lockdown==0
    S_i = repmat(ss.S_i,1, state_length);
elseif aux.steady_state==1 && aux.lockdown==1
    S_i_L = zeros(aux.x_grid*aux.alpha_grid, state_length);
    S_i_U = zeros(aux.x_grid*aux.alpha_grid, state_length);

elseif aux.steady_state==0 && aux.lockdown==1
    S_i_L = repmat(ss_ld.S_i_L,1, state_length);
    S_i_U = repmat(ss_ld.S_i_U,1, state_length);
    
end

% imputting out of lockdown values
if aux.steady_state==1 && aux.lockdown==1
    S_i = ss.S_i;
elseif aux.steady_state==1 && aux.lockdown==1
    S_i = laissez.S_i;
end



%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
% SURPLUS FIXED POINT ITERATIONS
%$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

while diff>aux.conv_diff
    
    if aux.lockdown==0
        
        S_i_new = (  + param.rho_y*S_r + param.nu*max(S_i,0) )...
            ./(param.r + param.delta + param.eta + param.nu + param.rho_y + ...
            repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) );  

        diff = max( abs( reshape(S_i_new,aux.x_grid*aux.alpha_grid*state_length,1) - ...
            reshape(S_i,aux.x_grid*aux.alpha_grid*state_length,1) ) ./ ...
            abs(reshape(S_i,aux.x_grid*aux.alpha_grid*state_length,1)) ); 
        S_i = S_i_new;
        
    elseif aux.lockdown==1 
        
 
      if aux.furlough==0
        S_i_L_new = (   param.rho_y*S_r_L + param.nu*max(S_i_L,0) + param.Lambda*S_i)...
            ./ (param.r + param.delta + param.eta + param.nu + param.rho_y + ...
            repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.Lambda);  
        
        S_i_U_new = ( param.rho_y*S_r_U + param.nu*max(S_i_U,0) + param.Lambda*S_i)...
            ./ (param.r + param.delta + param.eta + param.nu + param.rho_y + ...
            repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.Lambda);  

        
      elseif aux.furlough==1
        
        S_i_L_new = ( p2- param.b_u  + param.rho_y*max(S_r_L,S_r_L_2) + param.nu*max(S_i_L,0) + param.Lambda*S_i)...
            ./ (param.r + param.delta + param.eta + param.nu + param.rho_y + ...
            repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.Lambda);  
         
        S_i_U_new = ( p2- param.b_u  + param.rho_y*max(S_r_U,S_r_U_2) + param.nu*max(S_i_U,0) + param.Lambda*S_i)...
            ./ (param.r + param.delta + param.eta + param.nu + param.rho_y + ...
            repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.Lambda); 
       
      end   
        
            
        diff_L = max( abs( reshape(S_i_L_new,aux.x_grid*aux.alpha_grid*state_length,1) - ...
            reshape(S_i_L,aux.x_grid*aux.alpha_grid*state_length,1) ) ./ ...
            abs(reshape(S_i_L,aux.x_grid*aux.alpha_grid*state_length,1)) );
        
        diff_U = max( abs( reshape(S_i_U_new,aux.x_grid*aux.alpha_grid*state_length,1) - ...
            reshape(S_i_U,aux.x_grid*aux.alpha_grid*state_length,1) ) ./ ...
            abs(reshape(S_i_U,aux.x_grid*aux.alpha_grid*state_length,1)) );
        
        diff = max(diff_L,diff_U);
        
        S_i_L = S_i_L_new;
        S_i_U = S_i_U_new;
    end

          
end
     


    
    
    
    
    
    
    
    
    
    
    
    
    
    