us_grid = linspace(1e-6,aux.max_us,aux.us_grid); %there must be some unemployed or firm's wont post vacancies
ur_grid = linspace(0,aux.max_ur,aux.ur_grid);
li_grid = linspace(0,aux.max_li,aux.inf_grid);

[us_grid1,ur_grid1,li_grid1] = meshgrid(us_grid,ur_grid,li_grid);
    
    
% Death rate as a function of state variables
gamma_y_min = param.gamma_y*min(param.Theta./state_space(3,:), 1);
gamma_o_min = param.gamma_o*min(param.Theta./state_space(3,:), 1);

factor=5; %make sure this is large enough

% ALLOCATIONS IN MEMORY
% Time series: unemployment, retired and infection rate
us = zeros(1,factor*aux.T); ui = zeros(1,factor*aux.T); ur= zeros(1,factor*aux.T);
os = zeros(1,factor*aux.T); oi = zeros(1,factor*aux.T); or= zeros(1,factor*aux.T);
ell = zeros(1,factor*aux.T);

% Employment in state (alpha, x)
es0 = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
es1 = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
ei = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
er = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
 
% the same thing in lockdown
es0_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
es1_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
ei_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
er_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
 

us(1)= ss.u_s - aux.l_ini/3; 
ui(1) = aux.l_ini/3; 
ei(:,1) = ss.e_s*(aux.l_ini/3)/sum(ss.e_s);
es1((ss.e_s>0),1) = ss.e_s(ss.e_s>0) - ei((ss.e_s>0),1);  
os(1) = ss.o_s - aux.l_ini/3;
oi(1) = aux.l_ini/3;

ell(1) = (sum(ei(:,1)) + ui(1) + oi(1))/ ...
        (sum(es0(:,1)) + sum(es1(:,1)) + sum(ei(:,1)) ...
        + sum(er(:,1)) + us(1) + ui(1) + ur(1) ...
        + os(1) + oi(1) + or(1));
    
deaths = zeros(1,factor*aux.T);  %daily death rate
deaths_nat= zeros(1,factor*aux.T);  %daily death rate (natural causes)
phi_final = zeros(1,factor*aux.T); 

jfr = zeros(1,factor*aux.T);  %daily job finding rate
jsep = zeros(1,factor*aux.T);  %daily job separation rate
locked = zeros(1,factor*aux.T); %whether economy locked down (start not locked down)
mean_wage = zeros(1,factor*aux.T); %mean  of weekly wage at time t
var_wage = zeros(1,factor*aux.T); %variance of weekly wage at time  t
mean_wage_noinf= zeros(1,factor*aux.T); %mean  of weekly wage at time t (no infected included)
income= zeros(1,factor*aux.T); 


jfr(1) = 1- exp(-aux.dt*ss.phi*sum((ss.S_s>= 0).*f)*us(1));
jsep(1) = (1- exp(-aux.dt*(param.delta + param.eta)*sum(ss.e_s))); 

grid_test = zeros(1,factor*aux.T);
lock_dur = round(1/param.Lambda/aux.dt); %duration of lockdown


%%%%%%%%pre-allocated wages
ws0 = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws1 = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);

ws0_L_ld = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws1_L_ld = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi_L_ld = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr_L_ld = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);

w_tmp = p1 - (param.r+param.delta+param.eta)*(1-param.beta)*Ss1(:,end-1);
ws1(:,1) = w_tmp.*(es1(:,1)  > 0) -99*(es1(:,1)  <=0);
wi(:,1) = w_tmp.*(ei(:,1)  > 0) -99*(ei(:,1)  <=0);

% Mass threshold (set wage for states with less mass than this to (-99)
% (avoids dividing by very small numbers)
mass_thresh = 1e-60;

%%%%%%%%%%
t=1;
tt=0;

while tt < aux.T
    
    % TEMPORARY VARIABLES
    % Aggregate state at time t
    tmp_dist = abs( state_space - repmat([us(t);ur(t);ell(t)],1,state_length+2) ); 
    [~,grid] = min(sum(tmp_dist));
    
    
     % If there is no infection -- don't mind whether unemployed are
     % recovered or suceptible
     if state_space(3,grid)==0
        tmp_dist = abs(sum(state_space(1:2,:)) - repmat(us(t)+ur(t),1,state_length+2));
        [~,grid] = min(tmp_dist);
     end
    
    gamma_o_t = gamma_o_min(grid);
    gamma_y_t = gamma_y_min(grid);
    
    if locked(t)==0
    
        Ss0_t = Ss0(:,grid);
        Ss1_t = Ss1(:,grid);
        Ss_t = max(Ss0(:,grid),Ss1(:,grid));
        Si_t = Si(:,grid);
        Sr_t = Sr(:,grid);
        
        % TO INTERPOLATE
        phi_t = interp3(us_grid1,ur_grid1,li_grid1, reshape(phi(1:end-2),aux.us_grid,aux.ur_grid,aux.inf_grid), us(t),ur(t),ell(t),'cubic');
        phi_final(t)=phi_t;
        
        %%%%% Compute more (complex wage dynamics) %%%%%
        wage_dynamics;
        
        if t>1
            if locked(t-1)==1
                
                %reallocation following end of lockdown
                es0(:,t)        = es0(:,t) + es0_L_ld(:,t);
                es0_L_ld(:,t)   = zeros(aux.x_grid*aux.alpha_grid,1);
                es1(:,t)        = es1(:,t) + es1_L_ld(:,t);
                es1_L_ld(:,t)   = zeros(aux.x_grid*aux.alpha_grid,1);
                ei(:,t)         = ei(:,t)  + ei_L_ld(:,t);
                ei_L_ld(:,t)    = zeros(aux.x_grid*aux.alpha_grid,1);
                er(:,t)         = er(:,t)  + er_L_ld(:,t);
                er_L_ld(:,t)    = zeros(aux.x_grid*aux.alpha_grid,1);
                
            end
        end
        
        des0 = (1- exp(-aux.dt*us(t)*phi_t*(Ss0_t > Ss1_t).*(Ss_t >= 0).*f)) ...
            - (1- exp(-aux.dt*(param.delta + param.eta)*es0(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t < 0))) ...
            - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t >=0).*(Ss1_t >= Ss0_t))) ...
            + (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t >= 0).*(Ss1_t < Ss0_t))) ...
            - (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*ell(t)));

        des1 = (1- exp(-aux.dt*us(t)*phi_t*(Ss1_t >= Ss0_t).*(Ss_t >= 0).*f)) ...
            - (1- exp(-aux.dt*(param.delta + param.eta)*es1(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t < 0))) ...
            - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t >= 0).*(Ss1_t < Ss0_t))) ...
            + (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t >= 0).*(Ss1_t >= Ss0_t))) ...
            - (1- exp(-aux.dt*es1(:,t)*(param.lambda_0y + param.lambda_1y)*ell(t)));

        dei = (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*ell(t))) ...
            + (1- exp(-aux.dt*es1(:,t).*(param.lambda_0y + param.lambda_1y)*ell(t))) ...
            - (1- exp(-aux.dt*param.nu*ei(:,t).*(Si_t < 0))) ...
            - (1- exp(-aux.dt*(param.delta + param.rho_y + gamma_y_t + param.eta)*ei(:,t)));

        der = (1- exp(-aux.dt*ur(t)*phi_t*(Sr_t >= 0).*f))  ...
            + (1- exp(-aux.dt*param.rho_y*ei(:,t))) ...
            - (1- exp(-aux.dt*(param.delta + param.eta)*er(:,t))) ...
            - (1- exp(-aux.dt*param.nu*er(:,t).*(Sr_t < 0)));

        dus = (1- exp(-aux.dt*param.psi)) ...
            + (1- exp(-aux.dt*param.delta*(sum(es0(:,t)) + sum(es1(:,t)))))   ...
            + (1- exp(-aux.dt*param.nu*(sum(es0(:,t).*(Ss_t <0)) + sum(es1(:,t).*(Ss1_t <0))))) ...
            - (1- exp(-aux.dt*phi_t*sum((Ss_t >= 0).*f)*us(t))) ...
            - (1- exp(-aux.dt*param.lambda_0y*ell(t)*us(t))) ...
            - (1- exp(-aux.dt*param.eta*us(t)));

        dui = (1- exp(-aux.dt*param.delta*sum(ei(:,t))))  ...
            + (1- exp(-aux.dt*param.nu*sum((ei(:,t)).*(Si_t < 0)))) ...
            + (1- exp(-aux.dt*param.lambda_0y*ell(t)*us(t))) ...
            - (1- exp(-aux.dt*(param.rho_y + gamma_y_t + param.eta)*ui(t)));

        dur = (1- exp(-aux.dt*param.delta*sum(er(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum((er(:,t).*(Sr_t  < 0))))) ...
            + (1- exp(-aux.dt*param.rho_y*ui(t))) ...
            - (1- exp(-aux.dt*phi_t*sum((Sr_t >= 0).*f)*ur(t))) ...
            - (1- exp(-aux.dt*param.eta*ur(t)));

        dos = (1- exp(-aux.dt*param.eta*(us(t) + sum(es0(:,t)) + sum(es1(:,t))))) ...
            - (1- exp(-aux.dt*(param.lambda_0y*ell(t) + param.chi)*os(t)));    

        doi = (1- exp(-aux.dt*param.eta*(ui(t) + sum(ei(:,t))))) ...
            + (1- exp(-aux.dt*param.lambda_0y*ell(t)*os(t))) ...
            - (1- exp(-aux.dt*(gamma_o_t + param.chi + param.rho_o)*oi(t)));

        dor = (1- exp(-aux.dt*param.eta*(ur(t) + sum(er(:,t))))) ...
            + (1- exp(-aux.dt*param.rho_o*oi(t))) ...
            - (1- exp(-aux.dt*param.chi*or(t)));

        es0(:,t+1) = max(es0(:,t) + des0, 0);
        es1(:,t+1) = max(es1(:,t) + des1, 0);
        ei(:,t+1)  = max(ei(:,t)  + dei, 0);
        er(:,t+1)  = max(er(:,t)  + der, 0);

        us(t+1) = max(us(t) + dus,0);
        ui(t+1) = max(ui(t) + dui,0);
        ur(t+1) = max(ur(t) + dur,0);
        os(t+1) = max(os(t) + dos,0);
        oi(t+1) = max(oi(t) + doi,0);
        or(t+1) = max(or(t) + dor,0);

        ell(t+1) = (sum(ei(:,t+1)) + ui(t+1) + oi(t+1))/ ...
            (sum(es0(:,t+1)) + sum(es1(:,t+1)) + sum(ei(:,t+1)) ...
            + sum(er(:,t+1)) + us(t+1) + ui(t+1) + ur(t+1) ...
            + os(t+1) + oi(t+1) + or(t+1));

        deaths(t+1) = max(1- exp(-aux.dt*gamma_o_t*oi(t+1)) + ...
            1 - exp(-aux.dt*gamma_y_t*(ui(t+1) + sum(ei(:,t+1))) ),0);
        
        jfr(t+1) = (1- exp(-aux.dt*phi_t*sum((Ss_t >= 0).*f)*us(t))) + ...
                   (1- exp(-aux.dt*phi_t*sum((Sr_t >= 0).*f)*ur(t)));

        jsep(t+1) = (1- exp(-aux.dt*(param.delta + param.eta)*sum(es0(:,t)))) + ...
                    (1- exp(-aux.dt*param.nu*sum(es0(:,t).*(Ss_t < 0)))) + ...
                    (1- exp(-aux.dt*(param.delta + param.eta)*sum(es1(:,t)))) + ...
                    (1- exp(-aux.dt*param.nu*sum(es1(:,t).*(Ss_t < 0)))) + ...
                    (1- exp(-aux.dt*(param.delta + param.eta + gamma_y_t)*sum(ei(:,t)))) + ...
                    (1- exp(-aux.dt*param.nu*sum(ei(:,t).*(Si_t < 0)))) + ...
                    (1- exp(-aux.dt*(param.delta + param.eta)*sum(er(:,t)))) + ...
                    (1- exp(-aux.dt*param.nu*sum(er(:,t).*(Sr_t < 0))));
                 
                
    elseif locked(t)==1

        Ss0_L_ld_t = Ss0_L_ld(:,grid);
        Ss1_L_ld_t = Ss1_L_ld(:,grid);
        Ss_L_ld_t = max(Ss0_L_ld(:,grid),Ss1_L_ld(:,grid));  
        Si_L_ld_t = Si_L_ld(:,grid);
        Sr_L_ld_t = Sr_L_ld(:,grid);
        
        Ss0_U_ld_t = Ss0_U_ld(:,grid);
        Ss1_U_ld_t = Ss1_U_ld(:,grid);
        Ss_U_ld_t = max(Ss0_U_ld(:,grid),Ss1_U_ld(:,grid));  
        Si_U_ld_t = Si_U_ld(:,grid);
        Sr_U_ld_t = Sr_U_ld(:,grid);
        
        % TO INTERPOLATE
        phi_t = interp3(us_grid1,ur_grid1,li_grid1, reshape(phi_ld(1:end-2),aux.us_grid,aux.ur_grid,aux.inf_grid), us(t),ur(t),ell(t),'cubic');        
        phi_final(t)=phi_t;
        
        if locked(t-1)==0

            %initial reallocation following lockdown
            es0_L_ld(:,t) = param.pi*es0(:,t);
            es1_L_ld(:,t) = param.pi*es1(:,t);
            ei_L_ld(:,t)  = param.pi*ei(:,t);
            er_L_ld(:,t)  = param.pi*er(:,t);
            es0(:,t)      = (1 - param.pi)*es0(:,t);
            es1(:,t)      = (1 - param.pi)*es1(:,t);
            ei(:,t)       = (1 - param.pi)*ei(:,t);
            er(:,t)       = (1 - param.pi)*er(:,t);
        end
        
        %%%%% Compute more (complex wage dynamics) %%%%%
        wage_dynamics;
        
        %%%%%%%%%%%%% Susceptible %%%%%%%%%%%%%
        des0_L_ld = (1- exp(-aux.dt*param.pi*us(t)*phi_t*(Ss0_L_ld_t > Ss1_L_ld_t).*(Ss_L_ld_t >= 0).*f)) ...
            - (1- exp(-aux.dt*(param.delta)*es0_L_ld(:,t))) ...
            - (1- exp(-aux.dt*(param.eta)*es0_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(Ss_L_ld_t < 0))) ...
            - (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(Ss_L_ld_t >=0).*(Ss1_L_ld_t >= Ss0_L_ld_t))) ...
            + (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(Ss_L_ld_t >= 0).*(Ss1_L_ld_t < Ss0_L_ld_t))) ...
            - (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*ell(t)));
        
        des0_U_ld = (1- exp(-aux.dt*(1-param.pi)*us(t)*phi_t*(Ss0_U_ld_t > Ss1_U_ld_t).*(Ss_U_ld_t >= 0).*f)) ...
            - (1- exp(-aux.dt*(param.delta)*es0(:,t))) ...
            - (1- exp(-aux.dt*(param.eta)*es0(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_U_ld_t < 0))) ...
            - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_U_ld_t >=0).*(Ss1_U_ld_t >= Ss0_U_ld_t))) ...
            + (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_U_ld_t >= 0).*(Ss1_U_ld_t < Ss0_U_ld_t))) ...
            - (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*ell(t)));
        
        des1_L_ld = (1- exp(-aux.dt*param.pi*us(t)*phi_t*(Ss1_L_ld_t >= Ss0_L_ld_t).*(Ss_L_ld_t >= 0).*f)) ...
            - (1- exp(-aux.dt*(param.delta)*es1_L_ld(:,t))) ...
            - (1- exp(-aux.dt*(param.eta)*es1_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(Ss_L_ld_t < 0))) ...
            - (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(Ss_L_ld_t >= 0).*(Ss1_L_ld_t < Ss0_L_ld_t))) ...
            + (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(Ss_L_ld_t >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t))) ...
            - (1- exp(-aux.dt*es1_L_ld(:,t)*(param.lambda_0y_ld)*ell(t)));
        
        des1_U_ld = (1- exp(-aux.dt*(1-param.pi)*us(t)*phi_t*(Ss1_U_ld_t >= Ss0_U_ld_t).*(Ss_U_ld_t >= 0).*f)) ...
            - (1- exp(-aux.dt*(param.delta)*es1(:,t))) ...
            - (1- exp(-aux.dt*(param.eta)*es1(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_U_ld_t < 0))) ...
            - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_U_ld_t >= 0).*(Ss1_U_ld_t < Ss0_U_ld_t))) ...
            + (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_U_ld_t >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t))) ...
            - (1- exp(-aux.dt*es1(:,t)*(param.lambda_0y_ld + param.lambda_1y)*ell(t)));
        
     dus_ld = (1- exp(-aux.dt*param.psi)) ...
            + (1- exp(-aux.dt*param.delta*(sum(es0_L_ld(:,t)) + sum(es1_L_ld(:,t)) + sum(es0(:,t)) + sum(es1(:,t)))))   ...
            + (1- exp(-aux.dt*param.nu*(sum(es0_L_ld(:,t).*(Ss_L_ld_t <0)) + sum(es1_L_ld(:,t).*(Ss_L_ld_t <0)) + ...
                                        sum(es0(:,t).*(Ss_U_ld_t <0)) + sum(es1(:,t).*(Ss_U_ld_t <0))))) ...
            - (1- exp(-aux.dt*phi_t*(param.pi*sum((Ss_L_ld_t >= 0).*f)*us(t) + (1-param.pi)*sum((Ss_U_ld_t >= 0).*f)*us(t)))) ...
            - (1- exp(-aux.dt*param.lambda_0y_ld*ell(t)*us(t))) ...
            - (1- exp(-aux.dt*param.eta*us(t)));
        
        
        
       dos_ld = (1- exp(-aux.dt*param.eta*(us(t) + sum(es0_L_ld(:,t)) + sum(es0(:,t)) + sum(es1_L_ld(:,t)) + sum(es1(:,t))))) ...
              - (1- exp(-aux.dt*(param.lambda_0y_ld*ell(t) + param.chi)*os(t)));
           
       %%%%%%%%%%%%% Infected %%%%%%%%%%%%%   
       dei_L_ld = (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*ell(t))) ...
                 + (1- exp(-aux.dt*es1_L_ld(:,t)*param.lambda_0y_ld*ell(t))) ...
                 - (1- exp(-aux.dt*param.nu*ei_L_ld(:,t).*(Si_L_ld_t < 0))) ...
                 - (1- exp(-aux.dt*(param.delta + param.rho_y + gamma_y_t + param.eta)*ei_L_ld(:,t)));
        
       dei_U_ld = (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*ell(t))) ...
                 + (1- exp(-aux.dt*es1(:,t)*(param.lambda_0y_ld + param.lambda_1y)*ell(t))) ...
                 - (1- exp(-aux.dt*param.nu*ei(:,t).*(Si_U_ld_t < 0))) ...
                 - (1- exp(-aux.dt*(param.delta + param.rho_y + gamma_y_t + param.eta)*ei(:,t)));
        
      
       dui_ld = (1- exp(-aux.dt*param.delta*(sum(ei_L_ld(:,t))+sum(ei(:,t))))) ...
               + (1- exp(-aux.dt*param.nu*sum((ei_L_ld(:,t)).*(Si_L_ld_t < 0)))) ...
               + (1- exp(-aux.dt*param.nu*sum((     ei(:,t)).*(Si_U_ld_t < 0)))) ...
               + (1- exp(-aux.dt*param.lambda_0y_ld*ell(t)*us(t))) ...
               - (1- exp(-aux.dt*(param.rho_y + gamma_y_t + param.eta)*ui(t)));
        
       doi_ld = (1- exp(-aux.dt*param.eta*(ui(t) + sum(ei_L_ld(:,t)) + sum(ei(:,t))))) ...
               + (1- exp(-aux.dt*param.lambda_0y_ld*ell(t)*os(t)))  ...
               - (1- exp(-aux.dt*(gamma_o_t + param.chi + param.rho_o)*oi(t)));
           
        
              
        %%%%%%%%%%%%% Recovered %%%%%%%%%%%%%
        der_L_ld = (1- exp(-aux.dt*ur(t)*param.pi*phi_t*(Sr_L_ld_t >= 0).*f)) ...
            + (1- exp(-aux.dt*param.rho_y*ei_L_ld(:,t))) ...
            - (1- exp(-aux.dt*(param.delta + param.eta)*er_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.nu*er_L_ld(:,t).*(Sr_L_ld_t < 0)));
        
        der_U_ld = (1- exp(-aux.dt*ur(t)*(1-param.pi)*phi_t*(Sr_U_ld_t >= 0).*f)) ...
            + (1- exp(-aux.dt*param.rho_y*ei(:,t))) ...
            - (1- exp(-aux.dt*(param.delta + param.eta)*er(:,t))) ...
            - (1- exp(-aux.dt*param.nu*er(:,t).*(Sr_U_ld_t < 0)));
        
        dur_ld = (1- exp(-aux.dt*param.delta*(sum(er_L_ld(:,t)) + sum(er(:,t))))) ...
            + (1- exp(-aux.dt*param.nu*(sum((er_L_ld(:,t).*(Sr_L_ld_t  < 0))) + sum((er(:,t).*(Sr_U_ld_t  < 0)))))) ...
            + (1- exp(-aux.dt*param.rho_y*ui(t))) ...
            - (1- exp(-aux.dt*phi_t*(param.pi*sum((Sr_L_ld_t >= 0).*f)*ur(t) + (1-param.pi)*sum((Sr_U_ld_t >= 0).*f)*ur(t)))) ...
            - (1- exp(-aux.dt*param.eta*ur(t)));
      
        dor_ld =  (1- exp(-aux.dt*param.eta*(ur(t) + sum(er_L_ld(:,t)) + sum(er(:,t))))) ...
                + (1- exp(-aux.dt*param.rho_o*oi(t))) ...
                - (1- exp(-aux.dt*param.chi  *or(t)));
        
        %%%%%%%%%%%%% UPDATE %%%%%%%%%%%%%
        es0_L_ld(:,t+1) = max(es0_L_ld(:,t) + des0_L_ld, 0);
        es1_L_ld(:,t+1) = max(es1_L_ld(:,t) + des1_L_ld, 0);
        
        es0(:,t+1)      = max(es0(:,t)      + des0_U_ld, 0);
        es1(:,t+1)      = max(es1(:,t)      + des1_U_ld, 0);
        
        ei_L_ld(:,t+1)  = max(ei_L_ld(:,t)  + dei_L_ld,  0);
        ei(:,t+1)       = max(ei(:,t)       + dei_U_ld,  0);
        er_L_ld(:,t+1)  = max(er_L_ld(:,t)  + der_L_ld,  0);
        er(:,t+1)       = max(er(:,t)       + der_U_ld,  0);

        us(t+1) = max(us(t) + dus_ld,0);
        ui(t+1) = max(ui(t) + dui_ld,0);
        ur(t+1) = max(ur(t) + dur_ld,0);
        os(t+1) = max(os(t) + dos_ld,0);
        oi(t+1) = max(oi(t) + doi_ld,0);
        or(t+1) = max(or(t) + dor_ld,0);
            
        %%%%%%%%%%%%% Compute stats %%%%%%%%%%%%%
        ell(t+1) = (sum(ei_L_ld(:,t+1)) + sum(ei(:,t+1)) + ui(t+1) + oi(t+1))/ ...
            (sum(es0_L_ld(:,t+1)) + sum(es1_L_ld(:,t+1)) + sum(es0(:,t+1)) + sum(es1(:,t+1))  ...
           + sum(ei_L_ld(:,t+1))  + sum(ei(:,t+1)) + sum(er_L_ld(:,t+1)) +  sum(er(:,t+1)) ...
           + us(t+1) + ui(t+1) + ur(t+1) ...
           + os(t+1) + oi(t+1) + or(t+1));

        deaths(t+1) = max( (1- exp(-aux.dt*gamma_o_t*oi(t+1))) + ...
                           (1 -exp(-aux.dt*gamma_y_t*(ui(t+1) + sum(ei_L_ld(:,t+1)) + sum(ei(:,t+1))))), 0);
        
        jfr(t+1) = (1- exp(-aux.dt*phi_t*(param.pi *sum((Ss_L_ld_t >= 0).*f)*us(t) ...
                                     + (1-param.pi)*sum((Ss_U_ld_t >= 0).*f)*us(t)))) ...
                 + (1- exp(-aux.dt*phi_t*(param.pi *sum((Sr_L_ld_t >= 0).*f)*ur(t) ...
                                     + (1-param.pi)*sum((Sr_U_ld_t >= 0).*f)*ur(t))));
        
        jsep(t+1) = (1- exp(-aux.dt*(param.delta + param.eta)*sum(es0_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es0_L_ld(:,t).*(Ss_L_ld_t < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(es0(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es0(:,t).*(Ss_U_ld_t < 0))) ) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(es1_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es1_L_ld(:,t).*(Ss_L_ld_t < 0))) ) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(es1(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es1(:,t).*(Ss_U_ld_t < 0)))) ...
            + (1- exp(-aux.dt*param.nu*sum(ei_L_ld(:,t).*(Si_L_ld_t < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + gamma_y_t + param.eta)*sum(ei_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(ei(:,t).*(Si_U_ld_t < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + gamma_y_t + param.eta)*sum(ei(:,t))) ) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(er_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(er_L_ld(:,t).*(Sr_L_ld_t < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(er(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(er(:,t).*(Sr_U_ld_t < 0))));
                        
    end
    
    
    if tt>aux.t_period-1
        locked(t+1) =1;
    end
    if tt>aux.t_period + lock_dur-1
        locked(t+1) =0;
    end
    
    grid_test(t+1) = grid;
    
    if sum(deaths)*66.65*(10^6)>aux.death_ini
        if tt==0
            init=t;
        end
        tt=tt+1;
    end
        
    mean_wage(t) =( sum( (ws0_L_ld(:,t).*es0_L_ld(:,t) + ws1_L_ld(:,t).*es1_L_ld(:,t) + ws0(:,t).*es0(:,t) + ws1(:,t).*es1(:,t) + ...
                           wi_L_ld(:,t).*ei_L_ld(:,t)  + ei(:,t).*wi(:,t) + er_L_ld(:,t).*wr_L_ld(:,t) + er(:,t).*wr(:,t)))  ...
                  ) /...
                  (sum(es0_L_ld(:,t)) + sum(es1_L_ld(:,t)) + sum(es0(:,t)) + sum(es1(:,t)) + ...
                    sum(ei_L_ld(:,t)) + sum(ei(:,t)) + sum(er_L_ld(:,t)) + sum(er(:,t))   );
    
    
   mean_wage_noinf(t) =( sum( ( ws0_L_ld(:,t).*es0_L_ld(:,t) + ws1_L_ld(:,t).*es1_L_ld(:,t) + ...
                                ws0(:,t)     .*es0(:,t)      + ws1(:,t)     .*es1(:,t) + ...
                                wr_L_ld(:,t).*er_L_ld(:,t)   + wr(:,t)      .*er(:,t) ))  ...
                       ) /...
                    (sum(es0_L_ld(:,t)) + sum(es1_L_ld(:,t)) + sum(es0(:,t)) + sum(es1(:,t)) + ...
                     sum(er_L_ld(:,t)) + sum(er(:,t))   );
    
                   
    t=t+1;

end

or_t = or;  
os_t = os; 
oi_t = oi; 

locked = locked*param.pi;

outp = aux.dt*( p0'*(es0_L_ld + es0  + es1_L_ld + er_L_ld) + p1'*(es1 + er) + param.b_u*(us+ur) );

pop = sum(es0_L_ld) + sum(es0) ...
   +  sum(es1_L_ld) + sum(es1) ...
    + us +os...
    + sum(ei) + sum(ei_L_ld) ...
    + ui +oi ...
    + sum(er) + sum(er_L_ld) ...
    + ur +or ...
    ;

births = (1- exp(-aux.dt*param.psi))*ones(1,aux.T*factor);

emp =  sum(es0_L_ld)+ sum(es1_L_ld)+sum(es0) +sum(es1) + ... 
    + sum(ei) + sum(ei_L_ld) ...
    + sum(er) + sum(er_L_ld) ;

unemp = us+ur+ui;
old = or+oi+os;
