
param.psi=0;

%%%%START BEFORE LOCKDOWN%%%%%%%%%%%%
if aux.lockdown == 0   
    start_period = 24;
else
    start_period = aux.t_period;
end
t= start_period + init - 30; %this is 30 days prior to lockdown
t0=t;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
% Death rate as a function of state variables
gamma_y_min = param.gamma_y*min(param.Theta./state_space(3,:), 1);
gamma_o_min = param.gamma_o*min(param.Theta./state_space(3,:), 1);

factor=5; %make sure this is large enough

% ALLOCATIONS IN MEMORY
% Time series: unemployment, retired and infection rate
us = zeros(1,factor*aux.T); ui = zeros(1,factor*aux.T); ur= zeros(1,factor*aux.T);
os = zeros(1,factor*aux.T); oi = zeros(1,factor*aux.T); or= zeros(1,factor*aux.T);
ell = zeros(1,factor*aux.T);

% Employment in state (alpha, x)
es0 = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
es1 = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
es2 = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);

ei = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
ei2 = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);

er = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
er2 = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);

% the same thing in lockdown
es0_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
es1_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
es2_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);

ei_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
ei2_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);

er_L_ld  = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
er2_L_ld = zeros(aux.alpha_grid*aux.x_grid, factor*aux.T);
 
    
deaths = zeros(1,factor*aux.T);  %daily death rate
deaths_nat= zeros(1,factor*aux.T);  %daily death rate (natural causes)
 
furlough = zeros(1,factor*aux.T); % measure of people on furlough
mean_wage = zeros(1,factor*aux.T); %mean  of weekly wage at time t
var_wage = zeros(1,factor*aux.T); %variance of weekly wage at time t
mean_wage_noinf= zeros(1,factor*aux.T); %mean  of weekly wage at time t (no infected included)
 
 

% Wages in state (alpha, x)
ws0 = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws1 = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws2 = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi2 =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr2 =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws0_L_ld = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws1_L_ld = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws2_L_ld = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi_L_ld = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi2_L_ld =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr_L_ld =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr2_L_ld =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);

ws0_sq = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws1_sq = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws2_sq = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi_sq = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi2_sq =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr_sq = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr2_sq =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws0_L_ld_sq = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws1_L_ld_sq = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
ws2_L_ld_sq = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi_L_ld_sq = -99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wi2_L_ld_sq =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr_L_ld_sq =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
wr2_L_ld_sq =-99*ones(aux.alpha_grid*aux.x_grid, factor*aux.T);
 

if ini==0   %Use the steady state spread of employment 

   us(t) = 0;
    es1(:,t) = zeros(size(ss.e_s));
    w = p1 - (param.r+param.delta+param.eta)*(1-param.beta)*Ss1(:,end-1);
    es1(:,t) = ss.e_s/sum(ss.e_s);
    ws1(:,t) = w;
    
    os(t)=0;
else   % Start with a particular wage decile
    w = p1 - (param.r+param.delta+param.eta)*(1-param.beta)*Ss1(:,end-1);
    Es  = cumsum(ss.e_s); 
    Es = Es./Es(end); %the cdf of employees
    [~,gg] = min( abs(Es-ini/10));
    es_tmp = ss.e_s(gg:gg+aux.alpha_grid-1)./sum(ss.e_s(gg:gg+aux.alpha_grid-1));
    es1(gg:gg+aux.alpha_grid-1,t) = es_tmp;
    
    ws1(gg:gg+aux.alpha_grid-1,t) = w(gg)*ones(aux.alpha_grid,1);
    
end

% Mass threshold (set wage for states with less mass than this to (-99)
% (avoids dividing by very small numbers)
mass_thresh = 1e-60;

 
tt=0;
ini
while tt < (3*31)+t0 + 1 
    
    % TEMPORARY VARIABLES
    % Aggregate state at time t
    tmp_dist = abs( state_space - repmat([output.us_t(t);output.ur_t(t);output.ell_t(t)],1,state_length+2) ); 
    [~,grid] = min(sum(tmp_dist));
    
    
     % If there is no infection -- don't mind whether unemployed are
     % recovered or suceptible
     if state_space(3,grid)==0
        tmp_dist = abs(sum(state_space(1:2,:)) - repmat(output.us_t(t)+output.ur_t(t),1,state_length+2));
        [~,grid] = min(tmp_dist);
     end
    
    gamma_o_t = gamma_o_min(grid);
    gamma_y_t = gamma_y_min(grid);
    
    if output.locked(t)==0
    
        Ss0_t = Ss0(:,grid);
        Ss1_t = Ss1(:,grid);
        Ss_t = max(Ss0(:,grid),Ss1(:,grid));
        Si_t = Si(:,grid);
        Sr_t = Sr(:,grid);

        phi_t = interp3(us_grid1,ur_grid1,li_grid1, reshape(phi(1:end-2),aux.us_grid,aux.ur_grid,aux.inf_grid), output.us_t(t),output.ur_t(t),output.ell_t(t),'cubic');
        wage_dynamics_furlough;
        
        if t>1
            if output.locked(t-1)>0
                
                %reallocation following end of lockdown
                es0(:,t)      = es0(:,t) + es0_L_ld(:,t) + (Ss0_t>Ss1_t).*es2_L_ld(:,t)  + (Ss0_t>Ss1_t).*es2(:,t);
                es0_L_ld(:,t) = zeros(aux.x_grid*aux.alpha_grid,1);
                es1(:,t)      = es1(:,t) + es1_L_ld(:,t) + (Ss1_t>=Ss0_t).*es2_L_ld(:,t) + (Ss1_t>=Ss0_t).*es2(:,t);
                es1_L_ld(:,t) = zeros(aux.x_grid*aux.alpha_grid,1);
                es2(:,t)      = zeros(aux.x_grid*aux.alpha_grid,1);
                es2_L_ld(:,t) = zeros(aux.x_grid*aux.alpha_grid,1);
                
                ei(:,t)       = ei(:,t) + ei2(:,t) + ei_L_ld(:,t) + ei2_L_ld(:,t);
                ei2_L_ld(:,t) = zeros(aux.x_grid*aux.alpha_grid,1);
                ei2(:,t)      = zeros(aux.x_grid*aux.alpha_grid,1);
                ei_L_ld(:,t)  = zeros(aux.x_grid*aux.alpha_grid,1);
                
                er(:,t)       = er(:,t) + er2(:,t) + er_L_ld(:,t) + er2_L_ld(:,t);
                er_L_ld(:,t)  = zeros(aux.x_grid*aux.alpha_grid,1);
                er2(:,t)      = zeros(aux.x_grid*aux.alpha_grid,1);
                er2_L_ld(:,t) = zeros(aux.x_grid*aux.alpha_grid,1);
            end
        end
        
        des0 = (1- exp(-aux.dt*us(t)*phi_t*(Ss0_t > Ss1_t).*(Ss_t >= 0).*f)) ...
            - (1- exp(-aux.dt*(param.delta + param.eta)*es0(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t < 0))) ...
            - (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t >=0).*(Ss1_t >= Ss0_t))) ...
            + (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t >= 0).*(Ss1_t < Ss0_t))) ...
            - (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*output.ell_t(t)));

        des1 = (1- exp(-aux.dt*us(t)*phi_t*(Ss1_t >= Ss0_t).*(Ss_t >= 0).*f)) ...
            - (1- exp(-aux.dt*(param.delta + param.eta)*es1(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t < 0))) ...
            - (1- exp(-aux.dt*param.nu*es1(:,t).*(Ss_t >= 0).*(Ss1_t < Ss0_t))) ...
            + (1- exp(-aux.dt*param.nu*es0(:,t).*(Ss_t >= 0).*(Ss1_t >= Ss0_t))) ...
            - (1- exp(-aux.dt*es1(:,t)*(param.lambda_0y + param.lambda_1y)*output.ell_t(t)));

        dei = (1- exp(-aux.dt*es0(:,t)*param.lambda_0y*output.ell_t(t))) ...
            + (1- exp(-aux.dt*es1(:,t).*(param.lambda_0y + param.lambda_1y)*output.ell_t(t))) ...
            - (1- exp(-aux.dt*param.nu*ei(:,t).*(Si_t < 0))) ...
            - (1- exp(-aux.dt*(param.delta + param.rho_y + gamma_y_t + param.eta)*ei(:,t)));

        der = (1- exp(-aux.dt*ur(t)*phi_t*(Sr_t >= 0).*f)) + (1- exp(-aux.dt*param.rho_y*ei(:,t))) ...
            - (1- exp(-aux.dt*(param.delta + param.eta)*er(:,t))) - (1- exp(-aux.dt*param.nu*er(:,t).*(Sr_t < 0)));

        dus = (1- exp(-aux.dt*param.psi)) + (1- exp(-aux.dt*param.delta*(sum(es0(:,t)) + sum(es1(:,t)))))   ...
            + (1- exp(-aux.dt*param.nu*(sum(es0(:,t).*(Ss_t <0)) + sum(es1(:,t).*(Ss1_t <0))))) ...
            - (1- exp(-aux.dt*phi_t*sum((Ss_t >= 0).*f)*us(t))) ...
            - (1- exp(-aux.dt*param.lambda_0y*output.ell_t(t)*us(t))) - (1- exp(-aux.dt*param.eta*us(t)));

        dui = (1- exp(-aux.dt*param.delta*sum(ei(:,t)))) + (1- exp(-aux.dt*param.nu*sum((ei(:,t)).*(Si_t < 0)))) ...
            + (1- exp(-aux.dt*param.lambda_0y*output.ell_t(t)*us(t))) - (1- exp(-aux.dt*(param.rho_y + gamma_y_t + param.eta)*ui(t)));

        dur = (1- exp(-aux.dt*param.delta*sum(er(:,t)))) + (1- exp(-aux.dt*param.nu*sum((er(:,t).*(Sr_t  < 0))))) ...
            + (1- exp(-aux.dt*param.rho_y*ui(t))) - (1- exp(-aux.dt*phi_t*sum((Sr_t >= 0).*f)*ur(t))) - (1- exp(-aux.dt*param.eta*ur(t)));

        dos = (1- exp(-aux.dt*param.eta*(us(t) + sum(es0(:,t)) + sum(es1(:,t))))) - (1- exp(-aux.dt*(param.lambda_0y*output.ell_t(t) + param.chi)*os(t)));    

        doi = (1- exp(-aux.dt*param.eta*(ui(t) + sum(ei(:,t))))) ...
            + (1- exp(-aux.dt*param.lambda_0y*output.ell_t(t)*os(t))) - ...
            (1- exp(-aux.dt*(gamma_o_t + param.chi + param.rho_o)*oi(t)));

        dor = (1- exp(-aux.dt*param.eta*(ur(t) + sum(er(:,t))))) + (1- exp(-aux.dt*param.rho_o*oi(t))) - (1- exp(-aux.dt*param.chi*or(t)));

        es0(:,t+1) = max(es0(:,t) + des0, 0);
        es1(:,t+1) = max(es1(:,t) + des1, 0);
        ei(:,t+1) = max(ei(:,t) + dei, 0);
        er(:,t+1) = max(er(:,t) + der, 0);

        us(t+1) = max(us(t) + dus,0);
        ui(t+1) = max(ui(t) + dui,0);
        ur(t+1) = max(ur(t) + dur,0);
        os(t+1) = max(os(t) + dos,0);
        oi(t+1) = max(oi(t) + doi,0);
        or(t+1) = max(or(t) + dor,0);

        ell(t+1) = (sum(ei(:,t+1)) + ui(t+1) + oi(t+1))/ ...
            (sum(es0(:,t+1)) + sum(es1(:,t+1)) + sum(ei(:,t+1)) ...
            + sum(er(:,t+1)) + us(t+1) + ui(t+1) + ur(t+1) ...
            + os(t+1) + oi(t+1) + or(t+1));

        deaths(t+1) = max(1- exp(-aux.dt*gamma_o_t*oi(t+1)) + ...
            1 - exp(-aux.dt*gamma_y_t*(ui(t+1) + sum(ei(:,t+1))) ),0);
        
        jfr(t+1) = (1- exp(-aux.dt*phi_t*sum((Ss_t >= 0).*f)*us(t))) + ...
                   (1- exp(-aux.dt*phi_t*sum((Sr_t >= 0).*f)*ur(t)));

        jsep(t+1) = (1- exp(-aux.dt*(param.delta + param.eta)*sum(es0(:,t)))) + ...
                    (1- exp(-aux.dt*param.nu*sum(es0(:,t).*(Ss_t < 0)))) + ...
                    (1- exp(-aux.dt*(param.delta + param.eta)*sum(es1(:,t)))) + ...
                    (1- exp(-aux.dt*param.nu*sum(es1(:,t).*(Ss_t < 0)))) + ...
                    (1- exp(-aux.dt*(param.delta + param.eta + gamma_y_t)*sum(ei(:,t)))) + ...
                    (1- exp(-aux.dt*param.nu*sum(ei(:,t).*(Si_t < 0)))) + ...
                    (1- exp(-aux.dt*(param.delta + param.eta)*sum(er(:,t)))) + ...
                    (1- exp(-aux.dt*param.nu*sum(er(:,t).*(Sr_t < 0))));
        
        
        
                
    elseif output.locked(t) > 0

        Ss0_L_ld_t = Ss0_L_ld(:,grid);
        Ss1_L_ld_t = Ss1_L_ld(:,grid);
        Ss2_L_ld_t = Ss2_L_ld(:,grid);
        Ss_L_ld_t = max(Ss0_L_ld(:,grid),Ss1_L_ld(:,grid));  
        
        Si_L_ld_t = Si_L_ld(:,grid);
        
        Sr_L_ld_t = Sr_L_ld(:,grid);
        Sr2_L_ld_t = Sr2_L_ld(:,grid);
        
        Ss0_U_ld_t = Ss0_U_ld(:,grid);
        Ss1_U_ld_t = Ss1_U_ld(:,grid);
        Ss2_U_ld_t = Ss2_U_ld(:,grid);
        Ss_U_ld_t = max(Ss0_U_ld(:,grid),Ss1_U_ld(:,grid));  
        
        Si_U_ld_t = Si_U_ld(:,grid);
        
        Sr_U_ld_t = Sr_U_ld(:,grid);
        Sr2_U_ld_t = Sr2_U_ld(:,grid);
        
        phi_t = interp3(us_grid1,ur_grid1,li_grid1, reshape(phi_ld(1:end-2),aux.us_grid,aux.ur_grid,aux.inf_grid), output.us_t(t),output.ur_t(t),output.ell_t(t),'cubic');
        
        

        if output.locked(t-1)==0
            
            es0_tmp =es0(:,t); es1_tmp = es1(:,t);
            ei_tmp = ei(:,t);
            er_tmp = er(:,t);
            
            %initial reallocation following lockdown
            es0(:,t)      = (1 - param.pi)*es0_tmp;
            es1(:,t)      = (1 - param.pi)*es1_tmp;
            es2(:,t)      = zeros(aux.alpha_grid*aux.x_grid,1);
            es0_L_ld(:,t) = param.pi*es0_tmp;
            es1_L_ld(:,t) = param.pi*es1_tmp;
            es2_L_ld(:,t) = zeros(aux.alpha_grid*aux.x_grid,1);
            
            ei(:,t)       = (1 - param.pi)*ei_tmp;
            ei_L_ld(:,t)  = param.pi*ei_tmp;
            ei2(:,t)      = zeros(aux.alpha_grid*aux.x_grid,1);
            ei2_L_ld(:,t) = zeros(aux.alpha_grid*aux.x_grid,1);
            
            er(:,t)       = (1 - param.pi)*er_tmp;
            er_L_ld(:,t)  = param.pi*er_tmp;
            er2(:,t)      = zeros(aux.alpha_grid*aux.x_grid,1);
            er2_L_ld(:,t) = zeros(aux.alpha_grid*aux.x_grid,1);
            
            clear es0_tmp es1_tmp ei_tmp er_tmp

        end
        
        wage_dynamics_furlough;
        
        des0_L_ld = (1- exp(-aux.dt*param.pi*us(t)*phi_t*(Ss0_L_ld_t > Ss1_L_ld_t).*(Ss_L_ld_t >= 0).*f)) ...
            - (1- exp(-aux.dt*param.delta*es0_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.eta*es0_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) < 0))) ...
            - (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t | Ss2_L_ld_t > Ss0_L_ld_t) )) ...
            + (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t > Ss1_L_ld_t & Ss0_L_ld_t >= Ss2_L_ld_t) ) ) ...
            + (1- exp(-aux.dt*param.nu*es2_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t > Ss1_L_ld_t & Ss0_L_ld_t >= Ss2_L_ld_t) ) ) ...
            - (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*output.ell_t(t)));
        
        des1_L_ld = (1- exp(-aux.dt*param.pi*us(t)*phi_t*(Ss1_L_ld_t >= Ss0_L_ld_t).*(Ss_L_ld_t >= 0).*f)) ...
            - (1- exp(-aux.dt*param.delta*es1_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.eta*es1_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) < 0))) ...
            - (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t > Ss1_L_ld_t | Ss2_L_ld_t > Ss1_L_ld_t) )) ...
            + (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t & Ss1_L_ld_t >= Ss2_L_ld_t) ) ) ...
            + (1- exp(-aux.dt*param.nu*es2_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss1_L_ld_t >= Ss0_L_ld_t & Ss1_L_ld_t >= Ss2_L_ld_t) ) ) ...
            - (1- exp(-aux.dt*es1_L_ld(:,t)*(param.lambda_0y_ld)*output.ell_t(t)));
        
        des2_L_ld = - (1- exp(-aux.dt*param.delta*es2_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.eta*es2_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es2_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) < 0))) ...
            - (1- exp(-aux.dt*param.nu*es2_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss0_L_ld_t >= Ss2_L_ld_t | Ss1_L_ld_t >= Ss2_L_ld_t) )) ...
            + (1- exp(-aux.dt*param.nu*es0_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss2_L_ld_t > Ss0_L_ld_t & Ss2_L_ld_t > Ss1_L_ld_t) ) ) ...
            + (1- exp(-aux.dt*param.nu*es1_L_ld(:,t).*(max(Ss_L_ld_t,Ss2_L_ld_t) >= 0).*(Ss2_L_ld_t > Ss0_L_ld_t & Ss2_L_ld_t > Ss1_L_ld_t) ) ) ...
            - (1- exp(-aux.dt*es2_L_ld(:,t)*(param.lambda_0y_ld)*output.ell_t(t)));
        
        des0_U_ld = (1- exp(-aux.dt*(1-param.pi)*us(t)*phi_t*(Ss0_U_ld_t > Ss1_U_ld_t).*(Ss_U_ld_t >= 0).*f)) ...
            - (1- exp(-aux.dt*param.delta*es0(:,t))) ...
            - (1- exp(-aux.dt*param.eta*es0(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es0(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) < 0))) ...
            - (1- exp(-aux.dt*param.nu*es0(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t | Ss2_U_ld_t > Ss0_U_ld_t) )) ...
            + (1- exp(-aux.dt*param.nu*es1(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t > Ss1_U_ld_t & Ss0_U_ld_t >= Ss2_U_ld_t) ) ) ...
            + (1- exp(-aux.dt*param.nu*es2(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t > Ss1_U_ld_t & Ss0_U_ld_t >= Ss2_U_ld_t) ) ) ...
            - (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*output.ell_t(t)));
        
        des1_U_ld = (1- exp(-aux.dt*(1-param.pi)*us(t)*phi_t*(Ss1_U_ld_t >= Ss0_U_ld_t).*(Ss_U_ld_t >= 0).*f)) ...
            - (1- exp(-aux.dt*param.delta*es1(:,t))) ...
            - (1- exp(-aux.dt*param.eta*es1(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es1(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) < 0))) ...
            - (1- exp(-aux.dt*param.nu*es1(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t > Ss1_U_ld_t | Ss2_U_ld_t > Ss1_U_ld_t) )) ...
            + (1- exp(-aux.dt*param.nu*es0(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t & Ss1_U_ld_t >= Ss2_U_ld_t) ) ) ...
            + (1- exp(-aux.dt*param.nu*es2(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss1_U_ld_t >= Ss0_U_ld_t & Ss1_U_ld_t >= Ss2_U_ld_t) ) ) ...
            - (1- exp(-aux.dt*es1(:,t)*param.lambda_0y_ld*output.ell_t(t))) ...
            - (1- exp(-aux.dt*es1(:,t)*param.lambda_1y*output.ell_t(t))) ;
        
        
        des2_U_ld = - (1- exp(-aux.dt*param.delta*es2(:,t))) ...
            - (1- exp(-aux.dt*param.eta*es2(:,t))) ...
            - (1- exp(-aux.dt*param.nu*es2(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) < 0))) ...
            - (1- exp(-aux.dt*param.nu*es2(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss0_U_ld_t >= Ss2_U_ld_t | Ss1_U_ld_t >= Ss2_U_ld_t) )) ...
            + (1- exp(-aux.dt*param.nu*es0(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss2_U_ld_t > Ss0_U_ld_t & Ss2_U_ld_t > Ss1_U_ld_t) ) ) ...
            + (1- exp(-aux.dt*param.nu*es1(:,t).*( max(Ss_U_ld_t,Ss2_U_ld_t) >= 0).*(Ss2_U_ld_t > Ss0_U_ld_t & Ss2_U_ld_t > Ss1_U_ld_t) ) ) ...
            - (1- exp(-aux.dt*es2(:,t)*(param.lambda_0y_ld)*output.ell_t(t)));
        
        dei_L_ld = - (1- exp(-aux.dt*param.delta*ei_L_ld(:,t))) ...
                 - (1- exp(-aux.dt*param.rho_y*ei_L_ld(:,t))) ...
                 - (1- exp(-aux.dt*gamma_y_t*ei_L_ld(:,t))) ...
                 - (1- exp(-aux.dt*param.eta*ei_L_ld(:,t))) ...
                 - (1- exp(-aux.dt*param.nu*ei_L_ld(:,t))) ;
                
        dei2_L_ld = (1- exp(-aux.dt*es0_L_ld(:,t)*param.lambda_0y_ld*output.ell_t(t))) ...
                    + (1- exp(-aux.dt*es1_L_ld(:,t)*param.lambda_0y_ld*output.ell_t(t))) ...
                    + (1- exp(-aux.dt*es2_L_ld(:,t)*param.lambda_0y_ld*output.ell_t(t))) ...
                    - (1- exp(-aux.dt*param.delta*ei2_L_ld(:,t))) ...
                    - (1- exp(-aux.dt*param.rho_y*ei2_L_ld(:,t))) ...
                    - (1- exp(-aux.dt*gamma_y_t*ei2_L_ld(:,t))) ...
                    - (1- exp(-aux.dt*param.eta*ei2_L_ld(:,t))) ...
                    - (1- exp(-aux.dt*param.nu*ei2_L_ld(:,t).*(Si_L_ld_t<0) ))  ...
                    + (1- exp(-aux.dt*param.nu*ei_L_ld(:,t).*(Si_L_ld_t>=0) )) ;     
             
        dei_U_ld = - (1- exp(-aux.dt*param.delta*ei(:,t))) ...
                 - (1- exp(-aux.dt*param.rho_y*ei(:,t))) ...
                 - (1- exp(-aux.dt*gamma_y_t*ei(:,t))) ...
                 - (1- exp(-aux.dt*param.eta*ei(:,t))) ...
                 - (1- exp(-aux.dt*param.nu*ei(:,t))) ;
             
        dei2_U_ld  =  (1- exp(-aux.dt*es0(:,t)*param.lambda_0y_ld*output.ell_t(t))) ...
                    + (1- exp(-aux.dt*es1(:,t)*param.lambda_0y_ld*output.ell_t(t))) ...
                    + (1- exp(-aux.dt*es1(:,t)*param.lambda_1y*output.ell_t(t))) ...
                    + (1- exp(-aux.dt*es2(:,t)*(param.lambda_0y_ld)*output.ell_t(t))) ...
                    - (1- exp(-aux.dt*param.delta*ei2(:,t))) ...
                    - (1- exp(-aux.dt*param.rho_y*ei2(:,t))) ...
                    - (1- exp(-aux.dt*gamma_y_t*ei2(:,t))) ...
                    - (1- exp(-aux.dt*param.eta*ei2(:,t))) ...
                    - (1- exp(-aux.dt*param.nu*ei2(:,t).*(Si_U_ld_t < 0))) ...
                    + (1- exp(-aux.dt*param.nu*ei(:,t).*(Si_U_ld_t>=0) )) ; 
             
        der_L_ld = (1- exp(-aux.dt*ur(t)*param.pi*phi_t*(Sr_L_ld_t >= 0).*f)) ...
            + (1- exp(-aux.dt*param.rho_y*(ei_L_ld(:,t)).*(Sr_L_ld_t >= Sr2_L_ld_t) )) ...
            + (1- exp(-aux.dt*param.rho_y*(ei2_L_ld(:,t)).*(Sr_L_ld_t >= Sr2_L_ld_t) )) ...
            - (1- exp(-aux.dt*param.delta*er_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.eta*er_L_ld(:,t))) ...
            - (1- exp(-aux.dt*param.nu*er_L_ld(:,t) .*(max(Sr_L_ld_t,Sr2_L_ld_t) < 0))) ...
            - (1- exp(-aux.dt*param.nu*er_L_ld(:,t) .*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t > Sr_L_ld_t)   )) ...
            + (1- exp(-aux.dt*param.nu*er2_L_ld(:,t).*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t <= Sr_L_ld_t)   )) ; 
        
    
        der2_L_ld = + (1- exp(-aux.dt*param.rho_y*(ei_L_ld(:,t)).*(Sr_L_ld_t < Sr2_L_ld_t) )) ...
                    + (1- exp(-aux.dt*param.rho_y*(ei2_L_ld(:,t)).*(Sr_L_ld_t < Sr2_L_ld_t) )) ...
                    - (1- exp(-aux.dt*param.delta*er2_L_ld(:,t))) ...
                    - (1- exp(-aux.dt*param.eta*er2_L_ld(:,t))) ...
                    - (1- exp(-aux.dt*param.nu*er2_L_ld(:,t).*(max(Sr_L_ld_t,Sr2_L_ld_t) < 0))) ...
                    - (1- exp(-aux.dt*param.nu*er2_L_ld(:,t).*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t <= Sr_L_ld_t)   )) ...
                    + (1- exp(-aux.dt*param.nu*er_L_ld(:,t) .*(max(Sr_L_ld_t,Sr2_L_ld_t) >=0).*(Sr2_L_ld_t > Sr_L_ld_t)   )) ; 
        
        
        der_U_ld = (1- exp(-aux.dt*ur(t)*(1-param.pi)*phi_t*(Sr_U_ld_t >= 0).*f)) ...
            + (1- exp(-aux.dt*param.rho_y*(ei(:,t)).*(Sr_U_ld_t >= Sr2_U_ld_t) )) ...
            + (1- exp(-aux.dt*param.rho_y*(ei2(:,t)).*(Sr_U_ld_t >= Sr2_U_ld_t) )) ...
            - (1- exp(-aux.dt*param.delta*er(:,t))) ...
            - (1- exp(-aux.dt*param.eta*er(:,t))) ...
            - (1- exp(-aux.dt*param.nu*er(:,t) .*(max(Sr_U_ld_t,Sr2_U_ld_t) < 0))) ...
            - (1- exp(-aux.dt*param.nu*er(:,t) .*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*(Sr2_U_ld_t > Sr_U_ld_t)   )) ...
            + (1- exp(-aux.dt*param.nu*er2(:,t).*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*( Sr_U_ld_t >= Sr2_U_ld_t ) )) ; 
        
        
        der2_U_ld =   (1- exp(-aux.dt*param.rho_y*(ei(:,t)).*(Sr2_U_ld_t > Sr_U_ld_t ) )) ...
                    + (1- exp(-aux.dt*param.rho_y*(ei2(:,t)).*(Sr2_U_ld_t > Sr_U_ld_t ) )) ...
                    - (1- exp(-aux.dt*param.delta*er2(:,t))) ...
                    - (1- exp(-aux.dt*param.eta*er2(:,t))) ...
                    - (1- exp(-aux.dt*param.nu*er2(:,t).*(max(Sr_U_ld_t,Sr2_U_ld_t) < 0))) ...
                    - (1- exp(-aux.dt*param.nu*er2(:,t).*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*( Sr_U_ld_t >= Sr2_U_ld_t ) )) ...
                    + (1- exp(-aux.dt*param.nu*er(:,t) .*(max(Sr_U_ld_t,Sr2_U_ld_t) >=0).*(Sr2_U_ld_t > Sr_U_ld_t)   )) ; 
       
        
        dus_ld = (1- exp(-aux.dt*param.psi)) ...
            + (1- exp(-aux.dt*param.delta*(sum(es0_L_ld(:,t))  ))) ...
            + (1- exp(-aux.dt*param.delta*(sum(es1_L_ld(:,t))  ))) ...
            + (1- exp(-aux.dt*param.delta*(sum(es2_L_ld(:,t))  ))) ...
            + (1- exp(-aux.dt*param.delta*(sum(es0(:,t))  ))) ...
            + (1- exp(-aux.dt*param.delta*(sum(es1(:,t))  ))) ...
            + (1- exp(-aux.dt*param.delta*(sum(es2(:,t))  ))) ...
            + (1- exp(-aux.dt*param.nu*(sum( (es0_L_ld(:,t) ).* (max(Ss_L_ld_t,Ss2_L_ld_t) < 0 ) ) ) ) ) ...
            + (1- exp(-aux.dt*param.nu*(sum( (es1_L_ld(:,t) ).* (max(Ss_L_ld_t,Ss2_L_ld_t) < 0 ) ) ) ) ) ...
            + (1- exp(-aux.dt*param.nu*(sum( (es2_L_ld(:,t) ).* (max(Ss_L_ld_t,Ss2_L_ld_t) < 0 ) ) ) ) ) ...
            + (1- exp(-aux.dt*param.nu*(sum( (es0(:,t) ).* (max(Ss_U_ld_t,Ss2_U_ld_t) < 0 ) ) ) ) ) ...
            + (1- exp(-aux.dt*param.nu*(sum( (es1(:,t) ).* (max(Ss_U_ld_t,Ss2_U_ld_t) < 0 ) ) ) ) ) ...
            + (1- exp(-aux.dt*param.nu*(sum( (es2(:,t) ).* (max(Ss_U_ld_t,Ss2_U_ld_t) < 0 ) ) ) ) ) ...
            - (1- exp(-aux.dt*phi_t*(param.pi*sum((Ss_L_ld_t >= 0).*f)*us(t)) ) ) ...
            - (1- exp(-aux.dt*phi_t*((1-param.pi)*sum((Ss_U_ld_t >= 0).*f)*us(t) )) ) ...
            - (1- exp(-aux.dt*param.lambda_0y_ld*output.ell_t(t)*us(t))) ...
            - (1- exp(-aux.dt*param.eta*us(t)));
                
        dui_ld =  + (1- exp(-aux.dt*param.delta*(sum(ei_L_ld(:,t))     )))...
                  + (1- exp(-aux.dt*param.delta*(sum(ei(:,t))          )))...
                  + (1- exp(-aux.dt*param.delta*(sum(ei2_L_ld(:,t))    )))...
                  + (1- exp(-aux.dt*param.delta*(sum(ei2(:,t))         )))...
                  + (1- exp(-aux.dt*param.nu*sum( (ei_L_ld(:,t)).*(Si_L_ld_t<0) ) ) )     ... 
                  + (1- exp(-aux.dt*param.nu*sum( (ei2_L_ld(:,t) ).*(Si_L_ld_t<0) ) ) )   ... 
                  + (1- exp(-aux.dt*param.nu*sum( (ei(:,t)).*(Si_U_ld_t<0) ) ) )          ... 
                  + (1- exp(-aux.dt*param.nu*sum( (ei2(:,t)).*(Si_U_ld_t<0) ) ) )         ... 
                  + (1- exp(-aux.dt*param.lambda_0y_ld*output.ell_t(t)*us(t))) ...
                  - (1- exp(-aux.dt*param.rho_y*ui(t))) ...
                  - (1- exp(-aux.dt*gamma_y_t*ui(t))) ...
                  - (1- exp(-aux.dt*param.eta*ui(t))) ;
          
        
        dur_ld = (1- exp(-aux.dt*param.delta*(sum(er_L_ld(:,t)))    )) ...
               + (1- exp(-aux.dt*param.delta*(sum(er(:,t)))         )) ...
               + (1- exp(-aux.dt*param.delta*(sum(er2(:,t)))        )) ...
               + (1- exp(-aux.dt*param.delta*(sum(er2_L_ld(:,t)))   )) ...
            + (1- exp(-aux.dt*param.nu*( sum( (er_L_ld(:,t)).*(max(Sr_L_ld_t,Sr2_L_ld_t ) <0 ) ) ) ) ) ...
            + (1- exp(-aux.dt*param.nu*( sum( (er2_L_ld(:,t)).*(max(Sr_L_ld_t,Sr2_L_ld_t ) <0 ) ) ) ) ) ...
            + (1- exp(-aux.dt*param.nu*( sum( (er(:,t)).*(max(Sr_U_ld_t,Sr2_U_ld_t ) <0 ) ) ) ) ) ...
            + (1- exp(-aux.dt*param.nu*( sum( (er2(:,t)).*(max(Sr_U_ld_t,Sr2_U_ld_t ) <0 ) ) ) ) ) ...
            + (1- exp(-aux.dt*param.rho_y*ui(t))) ...
            - (1- exp(-aux.dt*phi_t*(param.pi*sum((Sr_L_ld_t >= 0).*f)*ur(t) ) ) )...
            - (1- exp(-aux.dt*phi_t*((1-param.pi)*sum((Sr_U_ld_t >= 0).*f)*ur(t)))) ...
            - (1- exp(-aux.dt*param.eta*ur(t)));

        
        dos_ld = (1- exp(-aux.dt*param.eta*(us(t))                      )) ...
                +(1- exp(-aux.dt*param.eta*(sum(es0_L_ld(:,t)))         )) ...                                 
                +(1- exp(-aux.dt*param.eta*(sum(es0(:,t)))              )) ...                             
                +(1- exp(-aux.dt*param.eta*(sum(es1_L_ld(:,t)))         )) ...
                +(1- exp(-aux.dt*param.eta*(sum(es1(:,t)))              )) ...
                +(1- exp(-aux.dt*param.eta*(sum(es2_L_ld(:,t)))         )) ... 
                +(1- exp(-aux.dt*param.eta*(sum(es2(:,t)))              )) ... 
                -(1- exp(-aux.dt*(param.lambda_0y_ld*output.ell_t(t))*os(t))) ...
                -(1- exp(-aux.dt*(param.chi)*os(t)));
        
           
        doi_ld = (1- exp(-aux.dt*param.eta*(ui(t))                                      )) ...
                +(1- exp(-aux.dt*param.eta*(sum(ei_L_ld(:,t)))                          )) ...
                +(1- exp(-aux.dt*param.eta*(sum(ei(:,t)))                               )) ...                                 
                +(1- exp(-aux.dt*param.eta*(sum(ei2_L_ld(:,t)))                         )) ...                            
                +(1- exp(-aux.dt*param.eta*(sum(ei2(:,t)))                              )) ...                                 
               + (1- exp(-aux.dt*param.lambda_0y_ld*output.ell_t(t)*os(t)))  ...
               - (1- exp(-aux.dt*gamma_o_t  *oi(t))) ...
               - (1- exp(-aux.dt*param.chi  *oi(t))) ...
               - (1- exp(-aux.dt*param.rho_o*oi(t)));
           
        
        dor_ld =   (1- exp(-aux.dt*param.eta*(ur(t))                )) ...
                 + (1- exp(-aux.dt*param.eta*(sum(er_L_ld(:,t)))    )) ...
                 + (1- exp(-aux.dt*param.eta*(sum(er(:,t)))         )) ...
                 + (1- exp(-aux.dt*param.eta*(sum(er2_L_ld(:,t)))   )) ...
                 + (1- exp(-aux.dt*param.eta*(sum(er2(:,t)))        )) ...
                 + (1- exp(-aux.dt*param.rho_o*oi(t))) ...
                 - (1- exp(-aux.dt*param.chi  *or(t)));
        
        es0_L_ld(:,t+1) = max(es0_L_ld(:,t) + des0_L_ld, 0);
        es1_L_ld(:,t+1) = max(es1_L_ld(:,t) + des1_L_ld, 0);
        es2_L_ld(:,t+1) = max(es2_L_ld(:,t) + des2_L_ld, 0);
         
        es0(:,t+1)      = max(es0(:,t)      + des0_U_ld, 0);
        es1(:,t+1)      = max(es1(:,t)      + des1_U_ld, 0);
        es2(:,t+1)      = max(es2(:,t)      + des2_U_ld, 0);
        
        ei_L_ld(:,t+1)  = max(ei_L_ld(:,t)  + dei_L_ld,  0);
        ei(:,t+1)       = max(ei(:,t)       + dei_U_ld,  0);
        ei2_L_ld(:,t+1) = max(ei2_L_ld(:,t) + dei2_L_ld, 0);
        ei2(:,t+1)      = max(ei2(:,t)      + dei2_U_ld, 0);
        
        er_L_ld(:,t+1)  = max(er_L_ld(:,t)  + der_L_ld,  0);
        er(:,t+1)       = max(er(:,t)       + der_U_ld,  0);

        er2_L_ld(:,t+1) = max(er2_L_ld(:,t) + der2_L_ld, 0);
        er2(:,t+1)      = max(er2(:,t)      + der2_U_ld, 0);
        
        us(t+1) = max(us(t) + dus_ld,0);
        ui(t+1) = max(ui(t) + dui_ld,0);
        ur(t+1) = max(ur(t) + dur_ld,0);
        os(t+1) = max(os(t) + dos_ld,0);
        oi(t+1) = max(oi(t) + doi_ld,0);
        or(t+1) = max(or(t) + dor_ld,0);
        
        ell(t+1) = ( sum(ei_L_ld(:,t+1)) + sum(ei(:,t+1)) +  sum(ei2_L_ld(:,t+1)) + sum(ei2(:,t+1)) + ui(t+1) + oi(t+1))/ ...
            (sum(es0_L_ld(:,t+1)) + sum(es1_L_ld(:,t+1)) + sum(es2_L_ld(:,t+1)) + sum(es0(:,t+1)) + sum(es1(:,t+1)) + sum(es2(:,t+1))  ...
           + sum(ei_L_ld(:,t+1))  + sum(ei(:,t+1)) + sum(ei2_L_ld(:,t+1))  + sum(ei2(:,t+1))  ...
           + sum(er_L_ld(:,t+1)) +  sum(er(:,t+1)) + sum(er2_L_ld(:,t+1)) +  sum(er2(:,t+1)) ...
           + us(t+1) + ui(t+1) + ur(t+1) ...
           + os(t+1) + oi(t+1) + or(t+1));

        deaths(t+1) = max(0, (1- exp(-aux.dt*gamma_o_t*oi(t+1)))                 ...
                             +(1 -exp(-aux.dt*gamma_y_t*sum(ei_L_ld(:,t+1)) ))   ...
                             +(1 -exp(-aux.dt*gamma_y_t*sum(ei(:,t+1))  ))       ...
                             +(1 -exp(-aux.dt*gamma_y_t*sum(ei2_L_ld(:,t+1))  )) ...
                             +(1 -exp(-aux.dt*gamma_y_t*sum(ei2(:,t+1)) ))       ...
                           );
                         
                         
                         
        jfr(t+1) = (1- exp(-aux.dt*phi_t*   param.pi *sum((Ss_L_ld_t >= 0).*f)*us(t))) ...
                 + (1- exp(-aux.dt*phi_t*(1-param.pi)*sum((Ss_U_ld_t >= 0).*f)*us(t))) ...
                 + (1- exp(-aux.dt*phi_t*   param.pi *sum((Sr_L_ld_t >= 0).*f)*ur(t))) ...
                 + (1- exp(-aux.dt*phi_t*(1-param.pi)*sum((Sr_U_ld_t >= 0).*f)*ur(t)));
        
        jsep(t+1) = (1- exp(-aux.dt*(param.delta + param.eta)*sum(es0_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es0_L_ld(:,t).*(max(Ss2_L_ld_t,Ss_L_ld_t) < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(es0(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es0(:,t).*(max(Ss2_U_ld_t,Ss_U_ld_t) < 0))) ) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(es1_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es1_L_ld(:,t).*(max(Ss2_L_ld_t,Ss_L_ld_t) < 0))) ) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(es1(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es1(:,t).*(max(Ss2_U_ld_t,Ss_U_ld_t) < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(es2_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es2_L_ld(:,t).*(max(Ss2_L_ld_t,Ss_L_ld_t) < 0))) ) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(es2(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(es2(:,t).*(max(Ss2_L_ld_t,Ss_L_ld_t) < 0)))) ...
            + (1- exp(-aux.dt*param.nu*sum(ei_L_ld(:,t).*(Si_L_ld_t < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + gamma_y_t + param.eta)*sum(ei_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(ei(:,t).*(Si_U_ld_t < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + gamma_y_t + param.eta)*sum(ei(:,t))) ) ...
            + (1- exp(-aux.dt*param.nu*sum(ei2_L_ld(:,t).*(Si_L_ld_t < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + gamma_y_t + param.eta)*sum(ei2_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(ei2(:,t).*(Si_U_ld_t < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + gamma_y_t + param.eta)*sum(ei2(:,t))) ) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(er_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(er_L_ld(:,t).*(max(Sr2_L_ld_t,Sr_L_ld_t) < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(er(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(er(:,t).*(max(Sr2_U_ld_t,Sr_U_ld_t) < 0)))) ...  
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(er2_L_ld(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(er2_L_ld(:,t).*(max(Sr2_L_ld_t,Sr_L_ld_t) < 0)))) ...
            + (1- exp(-aux.dt*(param.delta + param.eta)*sum(er2(:,t)))) ...
            + (1- exp(-aux.dt*param.nu*sum(er2(:,t).*(max(Sr2_U_ld_t,Sr_U_ld_t) < 0)))) ...
            ;
                          
    end
      
    
     
    t=t+1;  
    tt = tt+1;

end

or_t = or; 
os_t = os; 
oi_t = oi; 
 
outp = aux.dt*( p0'*(es0_L_ld + es1_L_ld + es0 + er_L_ld) + p1'*(es1 + er) ...
               + param.b_u*(us+ur)  ...  
               + param.b_u*sum(es2_L_ld + es2 + er2_L_ld + er2 ) ...
             );                      

pop = sum(es0_L_ld) + sum(es0) ...
    + sum(es1_L_ld) + sum(es1) ...
    + sum(es2_L_ld) + sum(es2) ...
    + us +os...
    + sum(ei) + sum(ei_L_ld) + sum(ei2) + sum(ei2_L_ld) ...
    + ui +oi ...
    + sum(er) + sum(er_L_ld) + sum(er2) + sum(er2_L_ld) ...
    + ur +or ...
    ;

furl = sum(es2_L_ld) +sum(es2)+ sum(ei2) + sum(ei2_L_ld) ...
     + sum(er2_L_ld) + sum(er2)   ;

emp =  sum(es0_L_ld)+ sum(es1_L_ld)+ sum(es2_L_ld)+sum(es0) +sum(es1) +sum(es2) ...
    + sum(ei) + sum(ei_L_ld) + sum(ei2) + sum(ei2_L_ld) + ...
    + sum(er) + sum(er_L_ld) + sum(er2) + sum(er2_L_ld);

unemp = us+ur+ui;
old = or+oi+os;


 
output_emp_inf.us_t(ini,:) = us(t0:t0+tt);
output_emp_inf.ui_t(ini,:) = ui(t0:t0+tt);
output_emp_inf.ur_t(ini,:) = ur(t0:t0+tt);
output_emp_inf.es0_L_ld_t(ini,:,:) = es0_L_ld(:,t0:t0+tt);
output_emp_inf.es1_L_ld_t(ini,:,:) = es1_L_ld(:,t0:t0+tt);
output_emp_inf.es2_L_ld_t(ini,:,:) = es2_L_ld(:,t0:t0+tt);
output_emp_inf.es0_t(ini,:,:) = es0(:,t0:t0+tt);
output_emp_inf.es1_t(ini,:,:) = es1(:,t0:t0+tt);
output_emp_inf.es2_t(ini,:,:) = es2(:,t0:t0+tt);
output_emp_inf.ei_L_ld_t(ini,:,:) = ei_L_ld(:,t0:t0+tt);
output_emp_inf.ei2_L_ld_t(ini,:,:) = ei2_L_ld(:,t0:t0+tt);
output_emp_inf.ei_t(ini,:,:) = ei(:,t0:t0+tt);
output_emp_inf.ei2_t(ini,:,:) = ei2(:,t0:t0+tt);
output_emp_inf.er_L_ld_t(ini,:,:) = er_L_ld(:,t0:t0+tt);
output_emp_inf.er2_L_ld_t(ini,:,:) = er2_L_ld(:,t0:t0+tt);
output_emp_inf.er_t(ini,:,:) = er(:,t0:t0+tt);
output_emp_inf.er2_t(ini,:,:) = er2(:,t0:t0+tt);
output_emp_inf.os_t(ini,:) = os_t(t0:t0+tt);
output_emp_inf.oi_t(ini,:) = oi_t(t0:t0+tt);
output_emp_inf.or_t(ini,:) = or_t(t0:t0+tt);
output_emp_inf.deaths(ini,:) = deaths(t0:t0+tt);



 





 