fprintf('\nprint figures 2 and 3\n')
clear
close all

% Load model solution
load('final_model.mat')

% load parameters
load('final_param.mat')

% Set length
aux.t_period=24;
TT = 365 + aux.t_period; 
days = (1:TT);


%% Figure 2
% shock
subplot(331)
plot(days,lf.locked(1:TT),'k-',...
     days,lck_3.locked(1:TT),'r-',...
     days,lck_6.locked(1:TT),'b-',...
    'linewidth',3)
xlabel('Days Since First Death')
%legend('Laissez faire', '3 Month Lockdown', '6 Month Lockdown', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT  0 max(lck_6.locked(1:TT))+0.05])
title('Lockdown Policy')


% total employemnt
lf_emp =  (sum(lf.es0_L_ld_t(:,1:TT)) + sum(lf.es1_L_ld_t(:,1:TT)) + ...
           sum(lf.es0_t(:,1:TT))      + sum(lf.es1_t(:,1:TT))  +...
           sum(lf.ei_L_ld_t(:,1:TT)) + sum(lf.ei_t(:,1:TT)) + ...
           sum(lf.er_L_ld_t(:,1:TT)) + sum(lf.er_t(:,1:TT)));
   
lck_3_emp=(sum(lck_3.es0_L_ld_t(:,1:TT)) + sum(lck_3.es1_L_ld_t(:,1:TT)) + ...
           sum(lck_3.es0_t(:,1:TT))      + sum(lck_3.es1_t(:,1:TT))  + ...
           sum(lck_3.ei_L_ld_t(:,1:TT))  + sum(lck_3.ei_t(:,1:TT)) + ...
           sum(lck_3.er_L_ld_t(:,1:TT))  + sum(lck_3.er_t(:,1:TT)));
    
lck_6_emp = (sum(lck_6.es0_L_ld_t(:,1:TT)) + sum(lck_6.es1_L_ld_t(:,1:TT)) + ...
             sum(lck_6.es0_t(:,1:TT))      + sum(lck_6.es1_t(:,1:TT))  +...
             sum(lck_6.ei_L_ld_t(:,1:TT))  + sum(lck_6.ei_t(:,1:TT)) + ...
             sum(lck_6.er_L_ld_t(:,1:TT))  + sum(lck_6.er_t(:,1:TT)));
    
 
subplot(332)
plot(days, lf_emp,'k-',...
     days, lck_3_emp,'r-', ...
     days, lck_6_emp,'b-', ...
      'linewidth',3);
xlabel('Days Since First Death')
%legend('Laissez faire', '3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0.52 0.56])
title('Total Employment')

% output
subplot(333)
plot(days,1*lf.outp(1:TT)./lf.outp(1),'k-',... 
     days,1*lck_3.outp(1:TT)./lf.outp(1),'r-',...
     days,1*lck_6.outp(1:TT)./lf.outp(1),'b-',...
    'linewidth',3)
xlabel('Days Since First Death')
%legend('Laissez faire', '3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0.75 1.1])
title('Aggregate Daily Output')


% deaths
subplot(334)
plot(days,lf.deaths(1:TT),'k-',...   
     days,lck_3.deaths(1:TT),'r-',...
     days,lck_6.deaths(1:TT),'b-',...
     'linewidth',3)
xlabel('Days Since First Death') 
%legend('Laissez faire', '3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT  0 0.0005])
title('Daily Fatility Rate')



% infected
subplot(335)
plot(days, (lf.ui_t(1:TT) + sum(lf.ei_L_ld_t(:,1:TT)) + sum(lf.ei_t(:,1:TT)) + lf.oi_t(1:TT)),'k-',...
     days, (lck_3.ui_t(1:TT) + sum(lck_3.ei_L_ld_t(:,1:TT)) + sum(lck_3.ei_t(:,1:TT)) + lck_3.oi_t(1:TT)),'r-',...
     days, (lck_6.ui_t(1:TT) + sum(lck_6.ei_L_ld_t(:,1:TT)) + sum(lck_6.ei_t(:,1:TT)) + lck_6.oi_t(1:TT)),'b-',...
'linewidth',3)
xlabel('Days Since First Death')
%legend('Laissez faire', '3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0 0.30])
title('Stock of Infected')



% susceptible
subplot(336)
plot(days,...
    (lf.us_t(1:TT) + sum(lf.es0_L_ld_t(:,1:TT)) + sum(lf.es1_L_ld_t(:,1:TT))+ sum(lf.es0_t(:,1:TT))+...
    sum(lf.es1_t(:,1:TT)) + lf.os_t(1:TT)),'k-',...
    days,...
       (lck_3.us_t(1:TT) + sum(lck_3.es0_L_ld_t(:,1:TT)) + sum(lck_3.es1_L_ld_t(:,1:TT))+ sum(lck_3.es0_t(:,1:TT))+...
    sum(lck_3.es1_t(:,1:TT)) + lck_3.os_t(1:TT)),'r-',...
    days,...
        (lck_6.us_t(1:TT) + sum(lck_6.es0_L_ld_t(:,1:TT)) + sum(lck_6.es1_L_ld_t(:,1:TT))+ sum(lck_6.es0_t(:,1:TT))+...
    sum(lck_6.es1_t(:,1:TT)) + lck_6.os_t(1:TT)),'b-',...
    'linewidth',3)
xlabel('Days Since First Death')
%legend('Laissez faire', '3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0 1])
title('Stock of Susceptible')


% Average wage
subplot(337)
plot(days,lf.mean_wage(:,1:TT)./lf.mean_wage(:,1),'k-', ...
     days,lck_3.mean_wage(:,1:TT)./lck_3.mean_wage(:,1),'r-', ...
     days,lck_6.mean_wage(:,1:TT)./lck_6.mean_wage(:,1),'b-', ...
      'linewidth',3)
 xlabel('Days Since First Death')
%legend('Laissez faire', '3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0.8 1.1])
title('Mean Weekly Wage')


% Total locked employment
lf_emp_locked = zeros(1,TT);
     
lck_3_emp_locked=(sum(lck_3.es0_L_ld_t(:,1:TT)) + sum(lck_3.es1_L_ld_t(:,1:TT)) +  ...
                 + sum(lck_3.ei_L_ld_t(:,1:TT))  + sum(lck_3.er_L_ld_t(:,1:TT)) );

lck_6_emp_locked = (sum(lck_6.es0_L_ld_t(:,1:TT)) + sum(lck_6.es1_L_ld_t(:,1:TT)) + ...
                  + sum(lck_6.ei_L_ld_t(:,1:TT))  + sum(lck_6.er_L_ld_t(:,1:TT)) );
 
   
subplot(338)
plot(days,( lf_emp_locked(1:TT))./lf_emp(:,1:TT),'k-', ...
     days,(lck_3_emp_locked(:,1:TT)./lck_3_emp(:,1:TT)),'r-', ...
     days,(lck_6_emp_locked(:,1:TT)./lck_6_emp(:,1:TT) ), 'b-',...
      'linewidth',3)
 xlabel('Days Since First Death')
%legend('Laissez faire', '3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0 0.20])
title('Proportion in Lockdown')


% total employment working from home
lf_emp_home    =  sum(lf.es0_t(:,1:TT));
lck_3_emp_home =  sum(lck_3.es0_t(:,1:TT));
lck_6_emp_home =  sum(lck_6.es0_t(:,1:TT));

subplot(339)
plot(days,lf_emp_home(:,1:TT), 'k-',... 
     days,lck_3_emp_home(:,1:TT), 'r-',... 
     days,lck_6_emp_home(:,1:TT) , 'b-', ... 
      'linewidth',3)
xlabel('Days Since First Death')
legend('Laissez faire', '3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0 0.015])
title('Stock of Voluntary Home-Working')
saveas(gcf,'BRS_Figure_2.png')



%% Figure 3
jfr_lf = lf.jfr(aux.t_period-4:aux.t_period+120+1);
jfr_lck_3 = lck_3.jfr(aux.t_period-4:aux.t_period+120+1);
jfr_lck_6 = lck_6.jfr(aux.t_period-4:aux.t_period+120+1);

jsep_lf = lf.jsep(aux.t_period-4:aux.t_period+120+1);
jsep_lck_3 = lck_3.jsep(aux.t_period-4:aux.t_period+120+1);
jsep_lck_6 = lck_6.jsep(aux.t_period-4:aux.t_period+120+1);
days_t_period = days(aux.t_period-5:aux.t_period+120)-aux.t_period;


figure(2)
subplot(121)
plot(days_t_period, jfr_lck_3,'r-', ...
     days_t_period, jfr_lck_6,'b-', ...
    'linewidth',3)
xlabel('Days Since Lockdown Implemented')
%legend('3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([-5 30 0.00079 0.00090])
title('Gross Hires')

subplot(122)
plot(days_t_period, jsep_lck_3,'r-', ...
    days_t_period, jsep_lck_6,'b-', ...
    'linewidth',3)
xlabel('Days Since Lockdown Implemented')
legend('3 Month Lockdown', '6 Month Lockdown','location','Northeast')
%set(gca,'fontsize',10)
axis([-5 30 0.0005 0.0025])
title('Gross Fires')
saveas(gcf,'BRS_Figure_3.png')










