fprintf('\nprint figures 6 and 8\n')
clear
close all

% Load model solution
load('final_model.mat')

% Load model solution with furlough
load('final_model_furlough.mat')

% Load parameters
load('final_param.mat')

% Set length
aux.t_period=24;
TT = 365*1 + aux.t_period; 
days = (1:TT);

%% Figure 6
% Shocks (epidemic with and without lockdown)
figure(1)
subplot(331)
plot(days,lf.locked(1:TT),'k-',...
     days,lck_6.locked(1:TT),'b-',...
     days,lck_f_6.locked(1:TT),'b--',...
    'linewidth',3)
xlabel('Days Since First Death')
%legend('Laissez faire','6 Month Lockdown','6 Month Lockdown + Furlough', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT  0 max(lck_6.locked(1:TT))+0.05])
title('Lockdown Policy')


% total employemnt
lf_emp=(sum(lf.es0_L_ld_t(:,1:TT))    + sum(lf.es1_L_ld_t(:,1:TT)) + ...
           sum(lf.es0_t(:,1:TT))      + sum(lf.es1_t(:,1:TT))      + ...
           sum(lf.ei_L_ld_t(:,1:TT))  + ...
           sum(lf.ei_t(:,1:TT))       +...
           sum(lf.er_L_ld_t(:,1:TT))  + ...
           sum(lf.er_t(:,1:TT))       ...
           );


lck_6_emp=(sum(lck_6.es0_L_ld_t(:,1:TT)) + sum(lck_6.es1_L_ld_t(:,1:TT)) + ...
           sum(lck_6.es0_t(:,1:TT))      + sum(lck_6.es1_t(:,1:TT))      + ...
           sum(lck_6.ei_L_ld_t(:,1:TT))  + ...
           sum(lck_6.ei_t(:,1:TT))       +...
           sum(lck_6.er_L_ld_t(:,1:TT))  + ...
           sum(lck_6.er_t(:,1:TT))       ...
           );
    
lck_f_6_emp = (sum(lck_f_6.es0_L_ld_t(:,1:TT)) + sum(lck_f_6.es1_L_ld_t(:,1:TT)) + sum(lck_f_6.es2_L_ld_t(:,1:TT)) + ...
               sum(lck_f_6.es0_t(:,1:TT))      + sum(lck_f_6.es1_t(:,1:TT))      + sum(lck_f_6.es2_t(:,1:TT))      + ...
               sum(lck_f_6.ei_L_ld_t(:,1:TT))  + sum(lck_f_6.ei2_L_ld_t(:,1:TT)) + ...
               sum(lck_f_6.ei_t(:,1:TT))       + sum(lck_f_6.ei2_t(:,1:TT))       + ...
               sum(lck_f_6.er_L_ld_t(:,1:TT))  + sum(lck_f_6.er2_L_ld_t(:,1:TT))  + ...
               sum(lck_f_6.er_t(:,1:TT))       + sum(lck_f_6.er2_t(:,1:TT)) ...
               );
    
 
subplot(332)
plot(days, lf_emp,'k-',... 
     days, lck_6_emp,'b-',... ...
     days, lck_f_6_emp,'b--',... ....
      'linewidth',3);
xlabel('Days Since First Death')
%legend('Laissez faire','6 Month Lockdown','6 Month Lockdown + Furlough', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0.52 0.56])
title('Total Employment')

% output
subplot(333)
plot(days,1*lf.outp(1:TT)./lf.outp(1),'k-',...
     days,1*lck_6.outp(1:TT)./lf.outp(1),'b-',...
     days,1*lck_f_6.outp(1:TT)./lf.outp(1),'b--',...
    'linewidth',3)
xlabel('Days Since First Death')
%legend('Laissez faire','6 Month Lockdown','6 Month Lockdown + Furlough', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0.7 1.1])
title('Aggregate Daily Output')

% deaths
subplot(334)
plot(days,lf.deaths(1:TT),'k-',...
     days,lck_6.deaths(1:TT),'b-',...    
     days,lck_f_6.deaths(1:TT),'b--',...
     'linewidth',3)
xlabel('Days Since First Death') 
%legend('Laissez faire','6 Month Lockdown','6 Month Lockdown + Furlough', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT  0 0.0005])
title('Daily Fatality Rate')

% infected
subplot(335)
plot(days, (lf.ui_t(1:TT)   + sum(lf.ei_L_ld_t(:,1:TT)) + sum(lf.ei_t(:,1:TT)) ...
                                   + lf.oi_t(1:TT)),'k-',...
     days, (lck_6.ui_t(1:TT)   + sum(lck_6.ei_L_ld_t(:,1:TT)) + sum(lck_6.ei_t(:,1:TT)) ...
                                   + lck_6.oi_t(1:TT)),'b-',...
     days, (lck_f_6.ui_t(1:TT) + sum(lck_f_6.ei_L_ld_t(:,1:TT)) + sum(lck_f_6.ei_t(:,1:TT)) ...
                                   + sum(lck_f_6.ei2_L_ld_t(:,1:TT)) + sum(lck_f_6.ei2_t(:,1:TT)) ...
                                   + lck_f_6.oi_t(1:TT)),'b--',...
'linewidth',3)
xlabel('Days Since First Death')
%legend('Laissez faire','6 Month Lockdown','6 Month Lockdown + Furlough', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0 0.30])
title('Stock of Infected')

% susceptible
subplot(336)
plot(days,(lf.us_t(1:TT) + sum(lf.es0_L_ld_t(:,1:TT)) + sum(lf.es1_L_ld_t(:,1:TT))  + ...
                         + sum(lf.es0_t(:,1:TT))      + sum(lf.es1_t(:,1:TT))        ...
                        + lf.os_t(1:TT)),'k-',... 
    days,(lck_6.us_t(1:TT) + sum(lck_6.es0_L_ld_t(:,1:TT)) + sum(lck_6.es1_L_ld_t(:,1:TT))  + ...
                            + sum(lck_6.es0_t(:,1:TT))      + sum(lck_6.es1_t(:,1:TT))        ...
                            + lck_6.os_t(1:TT)),'b-',... 
    days, (lck_f_6.us_t(1:TT) + sum(lck_f_6.es0_L_ld_t(:,1:TT)) + sum(lck_f_6.es1_L_ld_t(:,1:TT)) + sum(lck_f_6.es2_L_ld_t(:,1:TT)) + ...
                              + sum(lck_f_6.es0_t(:,1:TT))      + sum(lck_f_6.es1_t(:,1:TT))      + sum(lck_f_6.es2_t(:,1:TT)) + ...
                              lck_f_6.os_t(1:TT)),'b--',...
    'linewidth',3)
xlabel('Days Since First Death')
%legend('Laissez faire','6 Month Lockdown','6 Month Lockdown + Furlough', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0 1])
title('Stock of Susceptible')

% Average wage
subplot(337)
plot(days,lf.mean_wage(:,1:TT)./lf.mean_wage(:,1),'k-',... 
     days,lck_6.mean_wage(:,1:TT)./lck_6.mean_wage(:,1),'b-',...
     days,lck_f_6.mean_wage(:,1:TT)./lck_f_6.mean_wage(:,1),'b--',...
      'linewidth',3)
 xlabel('Days Since First Death')
%legend('Laissez faire','6 Month Lockdown','6 Month Lockdown + Furlough', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0.8 1.1])
title('Mean Weekly Wage')

% employment furloughed
lf_emp_furl       = zeros(1,TT);
lck_6_emp_furl    = zeros(1,TT);
lck_f_6_emp_furl  = sum(lck_f_6.es2_t(:,1:TT)      + lck_f_6.ei2_t(:,1:TT)      + lck_f_6.er2_t(:,1:TT) + ...
                        lck_f_6.es2_L_ld_t(:,1:TT) + lck_f_6.ei2_L_ld_t(:,1:TT) + lck_f_6.er2_L_ld_t(:,1:TT) );
                    
  lck_f_6_emp_ir_furl  = sum( lck_f_6.ei2_t(:,1:TT)      + lck_f_6.er2_t(:,1:TT) + ...
                         lck_f_6.ei2_L_ld_t(:,1:TT) + lck_f_6.er2_L_ld_t(:,1:TT) );
  
  lck_f_6_emp_ir_l_furl  = sum( lck_f_6.ei2_L_ld_t(:,1:TT) +...
                           lck_f_6.er2_L_ld_t(:,1:TT) );
     

subplot(338)
plot(days,lf_emp_furl(1:TT)./lf_emp(:,1:TT),'k-',...
     days,lck_6_emp_furl(1:TT)./lck_6_emp(:,1:TT),'b-',...
     days,lck_f_6_emp_furl(:,1:TT)./lck_f_6_emp(:,1:TT),'b--',...
      'linewidth',3)
xlabel('Days Since First Death')
%legend('Laissez faire','6 Month Lockdown','6 Month Lockdown + Furlough', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0 1])
title('Proportion of Employed on Furlough')

% total employment working from home
lf_emp_home =  sum(lf.es0_t(:,1:TT));
lck_6_emp_home =  sum(lck_6.es0_t(:,1:TT));
lck_f_6_emp_home =  sum(lck_f_6.es0_t(:,1:TT));
              
subplot(339)
plot(days,lf_emp_home(:,1:TT),'k-',...
     days,lck_6_emp_home(:,1:TT),'b-',...
     days,lck_f_6_emp_home(:,1:TT),'b--',...
      'linewidth',3)
xlabel('Days Since First Death')
legend('Laissez faire','6 Month Lockdown','6 Month Lockdown + Furlough', 'location','Northeast')
%set(gca,'fontsize',10)
axis([0 TT 0 0.015])
title('Stock of Voluntary Home-Working')

saveas(gcf,'BRS_Figure_6.png')



%% Figure 8 
%Set horizons
TT_1  = 365*1 + aux.t_period;
TT_2  = 365*2 + aux.t_period;


outcomes_1y = [100*(1-sum(lck_1.deaths(1:TT_1))), 100*sum(lck_1.outp(1:TT_1))/(lf.outp(1)*TT_1); ... 
              100*(1-sum(lck_2.deaths(1:TT_1))), 100*sum(lck_2.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
               100*(1-sum(lck_3.deaths(1:TT_1))), 100*sum(lck_3.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
                100*(1-sum(lck_4.deaths(1:TT_1))), 100*sum(lck_4.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
                 100*(1-sum(lck_5.deaths(1:TT_1))), 100*sum(lck_5.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
                  100*(1-sum(lck_6.deaths(1:TT_1))), 100*sum(lck_6.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
                  100*(1-sum(lck_12.deaths(1:TT_1))), 100*sum(lck_12.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
                  100*(1-sum(lck_18.deaths(1:TT_1))), 100*sum(lck_18.outp(1:TT_1))/(lf.outp(1)*TT_1);...
                  100*(1-sum(lck_24.deaths(1:TT_1))), 100*sum(lck_24.outp(1:TT_1))/(lf.outp(1)*TT_1);...
                  ];
             
             
outcomes_f_1y= [100*(1-sum(lck_f_1.deaths(1:TT_1))), 100*sum(lck_f_1.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
              100*(1-sum(lck_f_2.deaths(1:TT_1))), 100*sum(lck_f_2.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
              100*(1-sum(lck_f_3.deaths(1:TT_1))), 100*sum(lck_f_3.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
              100*(1-sum(lck_f_4.deaths(1:TT_1))), 100*sum(lck_f_4.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
               100*(1-sum(lck_f_5.deaths(1:TT_1))), 100*sum(lck_f_5.outp(1:TT_1))/(lf.outp(1)*TT_1); ...
                100*(1-sum(lck_f_6.deaths(1:TT_1))), 100*sum(lck_f_6.outp(1:TT_1))/(lf.outp(1)*TT_1); ];
                  



figure(2)
subplot(121)
plot(outcomes_1y(:,1), outcomes_1y(:,2),'k','linewidth',3); hold on;
plot(outcomes_f_1y(:,1), outcomes_f_1y(:,2),'b','linewidth',3); hold on;

scatter(100*(1-sum(lf.deaths(1:TT_1))),       100*sum(lf.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','r','linewidth',50);   hold on;
text(100*(1-sum(lf.deaths(1:TT_1))),100*sum(lf.outp(1:TT_1))/(lf.outp(1)*TT_1)+0.35,'laissez-faire','Color','r','FontSize',16)

scatter(100*(1-sum(lck_1.deaths(1:TT_1))),    100*sum(lck_1.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_2.deaths(1:TT_1))),    100*sum(lck_2.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_3.deaths(1:TT_1))),    100*sum(lck_3.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','k','linewidth',50);  hold on;

scatter(100*(1-sum(lck_4.deaths(1:TT_1))),    100*sum(lck_4.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_5.deaths(1:TT_1))),    100*sum(lck_5.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_6.deaths(1:TT_1))),    100*sum(lck_6.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','k','linewidth',50);  hold on;
text(100*(1-sum(lck_6.deaths(1:TT_1)))+0.05,    100*sum(lck_6.outp(1:TT_1))/(lf.outp(1)*TT_1),'6-month lockdown','Color','k','FontSize',16)

scatter(100*(1-sum(lck_12.deaths(1:TT_1))),   100*sum(lck_12.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_18.deaths(1:TT_1))),   100*sum(lck_18.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_24.deaths(1:TT_1))),   100*sum(lck_24.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','k','linewidth',50);  hold on;

scatter(100*(1-sum(lck_f_1.deaths(1:TT_1))), 100*sum(lck_f_1.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_2.deaths(1:TT_1))), 100*sum(lck_f_2.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_3.deaths(1:TT_1))), 100*sum(lck_f_3.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_4.deaths(1:TT_1))), 100*sum(lck_f_4.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_5.deaths(1:TT_1))), 100*sum(lck_f_5.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_6.deaths(1:TT_1))), 100*sum(lck_f_6.outp(1:TT_1))/(lf.outp(1)*TT_1),70,'filled','v','b','linewidth',50);  hold on;
text(100*(1-sum(lck_f_6.deaths(1:TT_1)))+0.05,  100*sum(lck_f_6.outp(1:TT_1))/(lf.outp(1)*TT_1),'6-month lockdown + furlough','Color','b','FontSize',16)

plot([100,100],[0,1000],'k--', 'linewidth',3)
plot([0,1000],[100,100],'k--', 'linewidth',3)
axis([98,100,92,100])
xlabel('Lives as a % of population')
ylabel('Output as a % of normal times')
%set(gca,'fontsize',20)
title('One year post lockdown')

outcomes_2y = [100*(1-sum(lck_1.deaths(1:TT_2))), 100*sum(lck_1.outp(1:TT_2))/(lf.outp(1)*TT_2); ... 
              100*(1-sum(lck_2.deaths(1:TT_2))), 100*sum(lck_2.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
               100*(1-sum(lck_3.deaths(1:TT_2))), 100*sum(lck_3.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                100*(1-sum(lck_4.deaths(1:TT_2))), 100*sum(lck_4.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                 100*(1-sum(lck_5.deaths(1:TT_2))), 100*sum(lck_5.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                  100*(1-sum(lck_6.deaths(1:TT_2))), 100*sum(lck_6.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                  100*(1-sum(lck_12.deaths(1:TT_2))), 100*sum(lck_12.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                  100*(1-sum(lck_18.deaths(1:TT_2))), 100*sum(lck_18.outp(1:TT_2))/(lf.outp(1)*TT_2);...
                  100*(1-sum(lck_24.deaths(1:TT_2))), 100*sum(lck_24.outp(1:TT_2))/(lf.outp(1)*TT_2);...
                  ];
             
             
outcomes_f_2y= [100*(1-sum(lck_f_1.deaths(1:TT_1))), 100*sum(lck_f_1.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                  100*(1-sum(lck_f_2.deaths(1:TT_2))), 100*sum(lck_f_2.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                  100*(1-sum(lck_f_3.deaths(1:TT_2))), 100*sum(lck_f_3.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                  100*(1-sum(lck_f_4.deaths(1:TT_2))), 100*sum(lck_f_4.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                   100*(1-sum(lck_f_5.deaths(1:TT_2))), 100*sum(lck_f_5.outp(1:TT_2))/(lf.outp(1)*TT_2); ...
                    100*(1-sum(lck_f_6.deaths(1:TT_2))), 100*sum(lck_f_6.outp(1:TT_2))/(lf.outp(1)*TT_2); ];
                  
           
           
figure(2)
subplot(122)

plot(outcomes_2y(:,1), outcomes_2y(:,2),'k','linewidth',3); hold on;
plot(outcomes_f_2y(:,1), outcomes_f_2y(:,2),'b','linewidth',3); hold on;


scatter(100*(1-sum(lf.deaths(1:TT_2))),       100*sum(lf.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','r','linewidth',50);   hold on;
   text(100*(1-sum(lf.deaths(1:TT_2))),          100*sum(lf.outp(1:TT_2))/(lf.outp(1)*TT_2)+0.35,'laissez-faire','Color','r','FontSize',16)

scatter(100*(1-sum(lck_1.deaths(1:TT_2))),    100*sum(lck_1.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','>','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_2.deaths(1:TT_2))),    100*sum(lck_2.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','>','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_3.deaths(1:TT_2))),    100*sum(lck_3.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','>','k','linewidth',50);  hold on;

scatter(100*(1-sum(lck_4.deaths(1:TT_2))),    100*sum(lck_4.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','>','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_5.deaths(1:TT_2))),    100*sum(lck_5.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','>','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_6.deaths(1:TT_2))),    100*sum(lck_6.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','k','linewidth',50);  hold on;
   text(100*(1-sum(lck_6.deaths(1:TT_2)))+0.05,  100*sum(lck_6.outp(1:TT_2))/(lf.outp(1)*TT_2),'6-month lockdown','Color','k','FontSize',16)

scatter(100*(1-sum(lck_12.deaths(1:TT_2))),   100*sum(lck_12.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_18.deaths(1:TT_2))),   100*sum(lck_18.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','k','linewidth',50);  hold on;
scatter(100*(1-sum(lck_24.deaths(1:TT_2))),   100*sum(lck_24.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','k','linewidth',50);  hold on;

scatter(100*(1-sum(lck_f_1.deaths(1:TT_2))), 100*sum(lck_f_1.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_2.deaths(1:TT_2))), 100*sum(lck_f_2.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_3.deaths(1:TT_2))), 100*sum(lck_f_3.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_4.deaths(1:TT_2))), 100*sum(lck_f_4.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_5.deaths(1:TT_2))), 100*sum(lck_f_5.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','b','linewidth',50);  hold on;
scatter(100*(1-sum(lck_f_6.deaths(1:TT_2))), 100*sum(lck_f_6.outp(1:TT_2))/(lf.outp(1)*TT_2),70,'filled','v','b','linewidth',50);  hold on;
  text(100*(1-sum(lck_f_6.deaths(1:TT_2)))+0.05,100*sum(lck_f_6.outp(1:TT_2))/(lf.outp(1)*TT_2),'6-month lockdown + furlough','Color','b','FontSize',16)

plot([100,100],[0,1000],'k--', 'linewidth',3)
plot([0,1000],[100,100],'k--', 'linewidth',3)
axis([98,100,92,100])
xlabel('Lives as a % of population')
ylabel('Output as a % of normal times')
%set(gca,'fontsize',20)
title('Two years post lockdown')

saveas(gcf,'BRS_Figure_8.png')


