function criterion = min_dist(theta, MOM, param,aux)

    param.kappa = abs(theta(1))*MOM(1);
    param.corr = abs(theta(2))/(1+abs(theta(2)));
    param.sigma_x = abs(theta(3));
    param.beta1 = abs(theta(4));
    param.beta2 = abs(theta(5));
    param.beta = abs(theta(6))/(1+abs(theta(6)));
    param.mu_x = theta(7);
    try   
        model_solve;

        moments.emp = states(2)/(states(1) + states(2));

        moments.v_stock=phi_f_new.^(1/(param.xi-1));

        e = phi*(S_s>=0).*f./(param.delta+param.eta);
        e = e./sum(e);

        home_wrk = betainv(alph,param.beta1,param.beta2);

        w = p1 - (param.r+param.delta+param.eta)*(1-param.beta)*S_s;

        moments.Eh = e'*home_wrk;
        sdh = (e'*(home_wrk.^2) - moments.Eh^2 )^(1/2);

        gg = (0:aux.alpha_grid:(aux.alpha_grid-1)*aux.x_grid);
        emp_a = zeros(aux.alpha_grid,1);
        for tt=1:aux.alpha_grid
            emp_a(tt) = sum(e(gg+tt));
        end
        clear gg tt

        Ea = cumsum(emp_a);
        moments.h9010 = interp1q([0;Ea],[0;home_wrk(1:aux.alpha_grid)],0.90) - ...
             interp1q([0;Ea],[0;home_wrk(1:aux.alpha_grid)],0.10);

        moments.h9010 = interp1q(Ea,home_wrk(1:aux.alpha_grid),0.90);

        moments.h9010 = interp1q([0;Ea],[0;home_wrk(1:aux.alpha_grid)],0.75) - ...
             interp1q([0;Ea],[0;home_wrk(1:aux.alpha_grid)],0.25);
        MOM(4) = 0.64; 
        
        moments.Ew = e'*w;

        lw = log(w);
        Elw = e'*lw;
        Elwh =  e'*(home_wrk.*lw);
        sdw = (e'*(lw.^2) - Elw^2)^(1/2);
        moments.corr_log_w_h = (Elwh - Elw*moments.Eh)/sdh/sdw;
        moments.lab_share = (e'*w)/(e'*p1);

      
        moments.hiring_cost = param.kappa/(e'*w*4);

        simmom = [moments.Ew; moments.emp; ...
            moments.Eh; ... 
            moments.h9010; moments.corr_log_w_h; ...
            moments.lab_share; ...
            moments.v_stock];

        criterion = (log(MOM) - log(simmom))'*(log(MOM) - log(simmom)); 
 
        [MOM,simmom]
    catch
       criterion = 1e3;
    end
    
end

