


SR_0_grids;

SR_1_RE;

discrep_tight = 1; iter_outer=1;
tic


while discrep_tight>aux.conv_diff
    
        
    phi_f = tight.^(param.xi-1); %xi is elast on vacancy
    phi = tight.*phi_f;
    
    % Recovered surplus and value functions
    SR_2_R;

    if aux.steady_state==0
        % Infected surplus and value functions
        SR_3_I;
        % Susceptible surplus and value functions
        SR_4_S;
    elseif aux.steady_state==1 && aux.lockdown==0   
        
        S_s = S_r;
    elseif aux.steady_state==1 && aux.lockdown==1  && aux.furlough==0
         
        S_s_L = S_r_L;
        S_s_U = S_r_U;
        
    elseif aux.steady_state==1 && aux.lockdown==1  && aux.furlough==1
        
        S_s_L = S_r_L;
        S_s_U = S_r_U;
        
        S_s2_L = S_r_L_2;
         
    end
    
    if aux.lockdown==0    
        phi_f_new = param.kappa./(...
            (1-param.beta)*u_s.*sum(max(S_s,0).*repmat(f,1,state_length ))./(u_s + u_r) + ...
            (1-param.beta)*u_r.*sum(max(S_r,0).*repmat(f,1,state_length ))./(u_s + u_r) );
    elseif aux.lockdown==1
        
        phi_f_new = param.kappa./(...
            (1-param.beta)*   param.pi *u_s.*sum(max(S_s_L,0).*repmat(f,1,state_length ))./(u_s + u_r) + ...
            (1-param.beta)*(1-param.pi)*u_s.*sum(max(S_s_U,0).*repmat(f,1,state_length ))./(u_s + u_r) + ...
            (1-param.beta)*   param.pi *u_r.*sum(max(S_r_L,0).*repmat(f,1,state_length ))./(u_s + u_r) + ...
            (1-param.beta)*(1-param.pi)*u_r.*sum(max(S_r_U,0).*repmat(f,1,state_length ))./(u_s + u_r) );        
    end
    
    tight_new = phi_f_new.^(1/(param.xi-1));    
       
    if aux.steady_state == 1  
                
        if aux.lockdown==0
           f0 = phi*sum( (S_r>=0).*f);
         elseif  aux.lockdown==1
           f0 = phi*sum( (S_r_L>=0).*f);
        end
            
        states = [(param.psi*(param.delta + param.eta)) ...
            /(param.delta*param.eta + param.eta*f0 + param.eta^2);
            (f0*param.psi)/(param.delta*param.eta + param.eta*f0 + param.eta^2);...
            param.psi/param.chi];

        u_s_new=states(1); u_r_new= 0; li_new = 0;
        
        u_s=u_s_new;
    end           
    
    discrep_tight = max( abs((tight_new - tight)./tight) ) + (iter_outer<3);
        
    if iter_outer<250
        tight = aux.update*tight_new + (1-aux.update)*tight;
    elseif iter_outer>249 &&  iter_outer<500
        tight = .1*aux.update*tight_new + (1-.1*aux.update)*tight;
    else
        disp('Model failed to converge');
        force error
    end
    
    if aux.display==1
        disp(['Discrepancy of tightness is ',...
            num2str(100*(discrep_tight - (iter_outer<3))),'%']);
    end
    
    
    iter_outer=iter_outer+1;
end

