%%%%%%%%%%%%%%%%
% WAGES
%%%%%%%%%%%%%%%%
% this code computes the equilibrium outcome of the Nash bargaining
% solution for the alpha and x and the state variables (at the point of
% negotiation)

%% out of lockdown wages

gamma_y_min = param.gamma_y*min(param.Theta./state_space(3,:), 1);
gamma_o_min = param.gamma_o*min(param.Theta./state_space(3,:), 1);
li_adj = [li, 0, 0];

wage_r = repmat(p1,1,state_length + 2) - (param.r + param.delta + param.eta + param.nu)*(1-param.beta)*Sr ... 
    + param.nu*(1-param.beta)*max(Sr,0);

wage_i = ( -(1-param.beta)*(param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.delta + param.eta + param.nu).*Si ...
    + param.nu*(1-param.beta)*max(Si,0) ...
    + (param.rho_y/(param.r + param.delta + param.eta + param.nu)).*(repmat(p1,1,state_length + 2) + param.nu*(1-param.beta).*max(Sr,0) ) ) ...
    *((param.r + param.delta + param.eta + param.nu)/(param.r + param.delta + param.eta + param.nu + param.rho_y) );

wage_s0_tmp = repmat(p0,1,state_length + 2) - (param.r + param.delta + param.eta + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) + param.nu)*(1-param.beta).*Ss0 ...
    + param.nu*(1-param.beta).*max(max(Ss0,Ss1),0) ...
    + (param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1)./(param.r + param.delta + param.eta + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.nu + param.rho_y) ).* ...
    ( (param.nu*(1-param.beta)*max(Si,0)) ...
    + (param.rho_y/(param.r + param.delta + param.eta + param.nu)).*(repmat(p1,1,state_length + 2) + param.nu*(1-param.beta).*max(Sr,0) ) );

wage_s0 = wage_s0_tmp.*(param.r + param.delta + param.eta + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.nu + param.rho_y).*(param.r + param.delta + param.eta + param.nu)...
    ./( (param.r + param.delta + param.eta + param.nu).*(param.r + param.delta + param.eta + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) + param.nu + param.rho_y) ...
    + param.rho_y*param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1)  );
clear wage_s0_tmp

wage_s1_tmp = repmat(p1,1,state_length + 2) - (param.r + param.delta + param.eta + (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) + param.nu)*(1-param.beta).*Ss1 ...
    + param.nu*(1-param.beta).*max(max(Ss0,Ss1),0) ...
    + ((param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1)./(param.r + param.delta + param.eta + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.nu + param.rho_y) ).* ...
    ( (param.nu*(1-param.beta)*max(Si,0)) ...
    + (param.rho_y/(param.r + param.delta + param.eta + param.nu)).*(repmat(p1,1,state_length + 2) + param.nu*(1-param.beta).*max(Sr,0) ) );

wage_s1 = wage_s1_tmp.*(param.r + param.delta + param.eta + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.nu + param.rho_y).*(param.r + param.delta + param.eta + param.nu)...
    ./( (param.r + param.delta + param.eta + param.nu).*(param.r + param.delta + param.eta + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) + param.nu + param.rho_y) ...
    + param.rho_y*(param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1)  );
clear wage_s1_tmp

if aux.lockdown==1 && aux.furlough==0
    wage_r_U_ld_tmp = repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr_U_ld,0)  ...
        - (param.r + param.delta + param.eta + param.nu  + param.Lambda)*(1-param.beta)*Sr_U_ld ...
        + (param.Lambda/( param.r + param.delta + param.eta + param.nu ) ).*...
        (repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr,0) );
    
    wage_r_U_ld = wage_r_U_ld_tmp*(param.r + param.delta + param.eta + param.nu)./(param.r + param.delta + param.eta + param.nu  + param.Lambda);
    clear wage_r_U_ld_tmp
    
    wage_r_L_ld_tmp = repmat(p0,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr_L_ld,0)  ...
        - (param.r + param.delta + param.eta + param.nu  + param.Lambda)*(1-param.beta)*Sr_L_ld ...
        + (param.Lambda/( param.r + param.delta + param.eta + param.nu ) ).*...
        (repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr,0) );
    
    wage_r_L_ld = wage_r_L_ld_tmp*(param.r + param.delta + param.eta + param.nu)./(param.r + param.delta + param.eta + param.nu  + param.Lambda);
    clear wage_r_L_ld_tmp
    
    wage_i_U_ld_tmp = -(1-param.beta)*(param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.delta + param.eta + param.nu + param.Lambda).*Si_U_ld ...
        + param.nu*(1-param.beta)*max(Si_U_ld,0)  ...
        + (param.rho_y/( param.r + param.delta + param.eta + param.nu +param.Lambda ) ).*(repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr_U_ld,0) ) ...
        + (param.Lambda./( param.r + param.delta + param.eta + param.nu + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) ) ).*...
        (param.nu*(1-param.beta)*max(Si,0) ) ...
        + ( (repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr,0) )./(param.r+param.delta+param.nu + param.eta) ).*...
        (param.rho_y*param.Lambda/( param.r + param.delta + param.eta + param.nu +param.Lambda ) + ...
        param.rho_y*param.Lambda./( param.r + param.delta + param.eta + param.nu + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) ) );
    
    wage_i_U_ld = wage_i_U_ld_tmp*( param.r + param.delta + param.eta + param.nu  ).*( param.r + param.delta + param.eta + param.nu + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) )./...
        ( ( param.r + param.delta + param.eta + param.nu  + param.rho_y).*( param.r + param.delta + param.eta + param.nu + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.Lambda)  );
    clear wage_i_U_ld_tmp
    
    
    wage_i_L_ld_tmp = -(1-param.beta)*(param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.delta + param.eta + param.nu + param.Lambda).*Si_L_ld ...
        + param.nu*(1-param.beta)*max(Si_L_ld,0)  ...
        + (param.rho_y/( param.r + param.delta + param.eta + param.nu +param.Lambda ) ).*(repmat(p0,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr_L_ld,0) ) ...
        + (param.Lambda./( param.r + param.delta + param.eta + param.nu + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) ) ).*...
        (param.nu*(1-param.beta)*max(Si,0) ) ...
        + ( (repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr,0) )./(param.r+param.delta+param.nu + param.eta) ).*...
        (param.rho_y*param.Lambda/( param.r + param.delta + param.eta + param.nu +param.Lambda ) + ...
        param.rho_y*param.Lambda./( param.r + param.delta + param.eta + param.nu + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) ) );
    
    wage_i_L_ld = wage_i_L_ld_tmp*( param.r + param.delta + param.eta + param.nu  ).*( param.r + param.delta + param.eta + param.nu + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) )./...
        ( ( param.r + param.delta + param.eta + param.nu  + param.rho_y).*( param.r + param.delta + param.eta + param.nu + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.Lambda)  );
    clear wage_i_L_ld_tmp
    
    
    %solve iteratively 
    for contract=1:4
        wage = wage_r_L_ld; %initial guess
        wage_discrep=10;
        while wage_discrep>1e-2 
            
                Jr  =  (repmat(p1,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(Sr,0) )/(param.r + param.delta + param.eta + param.nu);
                
                Ji  =  (- wage + param.rho_y*Jr + param.nu*(1-param.beta)*max(Si,0) )...
                    ./(param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) +  param.delta + param.eta + param.nu );
                
                Js0 = ( repmat(p0,1,state_length + 2) - wage +  param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji + param.nu*(1-param.beta)*max(max(Ss0,Ss1),0) ) ./ ...
                    ( param.r + param.delta + param.eta + param.nu +   param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) );
                
                Js1 = ( repmat(p1,1,state_length + 2) - wage +  (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji + param.nu*(1-param.beta)*max(max(Ss0,Ss1),0) ) ./ ...
                    ( param.r + param.delta + param.eta + param.nu +   (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) );

                Jr_U = (repmat(p1,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(Sr_U_ld,0) + param.Lambda*Jr )/(param.r + param.delta + param.eta + param.nu + param.Lambda);
                
                Jr_L = (repmat(p0,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(Sr_L_ld,0) + param.Lambda*Jr )/(param.r + param.delta + param.eta + param.nu + param.Lambda);

                Ji_U = ( - wage + param.rho_y*Jr_U + param.nu*(1-param.beta)*max(Si_U_ld,0) + param.Lambda*Ji )./ ...
                    (param.r + param.rho_y + param.delta + param.eta + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.nu + param.Lambda);
                
                Ji_L = ( - wage + param.rho_y*Jr_L + param.nu*(1-param.beta)*max(Si_L_ld,0) + param.Lambda*Ji )./ ...
                    (param.r + param.rho_y + param.delta + param.eta + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.nu + param.Lambda);
    
    
            if contract==1
                %this is s0 and unlocked
                wage_new= repmat(p0,1,state_length + 2) + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_U ...
                    + param.nu*(1-param.beta)*max(0,max(Ss0_U_ld,Ss1_U_ld)) ...
                    + param.Lambda*Js0 ...
                    - (1-param.beta)*( param.r + param.delta + param.eta + param.nu +   param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss0_U_ld;
                wage_s0_U_ld = wage_new;
            elseif contract==2
                %this is s1 and unlocked
                wage_new = repmat(p1,1,state_length + 2) + (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_U ...
                        + param.nu*(1-param.beta)*max(0,max(Ss0_U_ld,Ss1_U_ld)) ...
                        + param.Lambda*Js1 ...
                        - (1-param.beta)*( param.r + param.delta + param.eta + param.nu +   (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss1_U_ld;
                wage_s1_U_ld = wage_new;    
            elseif contract==3
                %this is s0 and locked
                wage_new = repmat(p0,1,state_length + 2) + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_L ...
                        + param.nu*(1-param.beta)*max(0,max(Ss0_L_ld,Ss1_L_ld)) ...
                        + param.Lambda*Js0 ...
                        - (1-param.beta)*( param.r + param.delta + param.eta + param.nu +   param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss0_L_ld;
                wage_s0_L_ld = wage_new;    
            elseif contract==4
                %this is s1 and locked
                wage_new =  repmat(p0,1,state_length + 2) + (param.lambda_0y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_L ...
                        + param.nu*(1-param.beta)*max(0,max(Ss0_L_ld,Ss1_L_ld)) ...
                        + param.Lambda*Js1 ...
                        - (1-param.beta)*( param.r + param.delta + param.eta + param.nu +   (param.lambda_0y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss1_L_ld;
                wage_s1_L_ld = wage_new;     
            end
            wage_discrep = max(max(abs(wage_new - wage) ));
            wage =0.5*wage_new+0.5*wage;
        end 
    end
    
elseif aux.lockdown==1 && aux.furlough==1
    
    % Solve wages of recovered   
    wage_r_U_ld_tmp = repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(max(Sr2_U_ld,Sr_U_ld),0)  ... 
        - (param.r + param.delta + param.eta + param.nu  + param.Lambda)*(1-param.beta)*Sr_U_ld ...
        + (param.Lambda/( param.r + param.delta + param.eta + param.nu ) ).*...
        (repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr,0) );
    
    wage_r_U_ld = wage_r_U_ld_tmp*(param.r + param.delta + param.eta + param.nu)./(param.r + param.delta + param.eta + param.nu  + param.Lambda);
    clear wage_r_U_ld_tmp


    wage_r_L_ld_tmp = repmat(p0,1,state_length + 2) + param.nu*(1-param.beta)*max(max(Sr_L_ld,Sr2_L_ld),0)  ...
        - (param.r + param.delta + param.eta + param.nu  + param.Lambda)*(1-param.beta)*Sr_L_ld ...
        + (param.Lambda/( param.r + param.delta + param.eta + param.nu ) ).*...
        (repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr,0) );
    
    wage_r_L_ld = wage_r_L_ld_tmp*(param.r + param.delta + param.eta + param.nu)./(param.r + param.delta + param.eta + param.nu  + param.Lambda);
    clear wage_r_L_ld_tmp


    wage_r2_U_ld_tmp = repmat(p2,1,state_length + 2) + param.nu*(1-param.beta)*max(max(Sr2_U_ld,Sr_U_ld),0)  ...
        - (param.r + param.delta + param.eta + param.nu  + param.Lambda)*(1-param.beta)*Sr2_U_ld ...
        + (param.Lambda/( param.r + param.delta + param.eta + param.nu ) ).*...
        (repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr,0) );
    
    wage_r2_U_ld = wage_r2_U_ld_tmp*(param.r + param.delta + param.eta + param.nu)./(param.r + param.delta + param.eta + param.nu  + param.Lambda);
    clear wage_r2_U_ld_tmp


    wage_r2_L_ld_tmp = repmat(p2,1,state_length + 2) + param.nu*(1-param.beta)*max(max(Sr_L_ld,Sr2_L_ld),0)  ...
        - (param.r + param.delta + param.eta + param.nu  + param.Lambda)*(1-param.beta)*Sr2_L_ld ...
        + (param.Lambda/( param.r + param.delta + param.eta + param.nu ) ).*...
        (repmat(p1,1,state_length + 2) + param.nu*(1-param.beta)*max(Sr,0) );
    
    wage_r2_L_ld = wage_r2_L_ld_tmp*(param.r + param.delta + param.eta + param.nu)./(param.r + param.delta + param.eta + param.nu  + param.Lambda);
    clear wage_r_L_ld_tmp
    
    
    % Solve wages of infected
    for contract=1:2
        wage = zeros(length(p1),state_length + 2); %initial guess
        wage_discrep=10;

        while wage_discrep>1e-2 

            Jr    = (repmat(p1,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(Sr,0) )/...
                (param.r + param.delta + param.eta + param.nu);

            Jr_U  = (repmat(p1,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(max(Sr_U_ld,Sr2_U_ld),0) + param.Lambda*Jr )/...
                (param.r + param.delta + param.eta + param.nu + param.Lambda);
            
            Jr_L  = (repmat(p0,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(max(Sr_L_ld,Sr2_L_ld),0) + param.Lambda*Jr )/...
                (param.r + param.delta + param.eta + param.nu + param.Lambda);
 
            Jr2_U = (repmat(p2,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(max(Sr_U_ld,Sr2_U_ld),0) + param.Lambda*Jr )/...
                (param.r + param.delta + param.eta + param.nu + param.Lambda);
            
            Jr2_L = (repmat(p2,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(max(Sr_L_ld,Sr2_L_ld),0) + param.Lambda*Jr )/...
                (param.r + param.delta + param.eta + param.nu + param.Lambda);
 
            Ji    =  (- wage + param.rho_y*Jr + param.nu*(1-param.beta)*max(Si,0)   )...
                     ./(param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) +  param.delta + param.eta + param.nu);
             
                   
            % Use the value of a job with an infected workers during lockdown
            if contract==1  %unlocked
                wage_new  = ...
                    repmat(p2-param.b_u,1,state_length + 2) ...
                    - (1-param.beta)*(param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) +  param.delta + param.eta + param.nu + param.Lambda).*Si_U_ld ... 
                    + param.rho_y.*(Sr_U_ld>=Sr2_U_ld).*Jr_U + param.rho_y.*(Sr_U_ld< Sr2_U_ld).*Jr2_U ...  
                    + param.nu*(1-param.beta)*max(Si_U_ld,0) ...
                    + param.Lambda*Ji;
                wage_i_U_ld  = wage_new;
                wage_i2_U_ld = wage_new;
      
            elseif contract==2 %locked
                wage_new = ...
                    repmat(p2-param.b_u,1,state_length + 2)  ...
                     - (1-param.beta)*(param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) + param.delta + param.eta + param.nu + param.Lambda).*Si_L_ld ... 
                     + param.rho_y.*(Sr_L_ld>=Sr2_L_ld).*Jr_L + param.rho_y.*(Sr_L_ld< Sr2_L_ld).*Jr2_L ...  
                     + param.nu*(1-param.beta)*max(Si_L_ld,0)  ...
                     + param.Lambda*Ji;
                wage_i_L_ld   = wage_new;
                wage_i2_L_ld  = wage_new;
            end

            wage_discrep = max(max(abs(wage_new - wage) ))
            wage =0.5*wage_new+0.5*wage;
       end

    end
    
    % Solve wages of susceptible (s0, s1, s2 unlocked and locked)
    %solve iteratively
    for contract=1:6
        wage = zeros(length(p1),state_length + 2); %initial guess
        wage_discrep=10;
        
        while wage_discrep>1e-2
            
                Jr    = (repmat(p1,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(Sr,0) )/...
                        (param.r + param.delta + param.eta + param.nu);

                Jr_U  = (repmat(p1,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(max(Sr_U_ld,Sr2_U_ld),0) + param.Lambda*Jr )/...
                        (param.r + param.delta + param.eta + param.nu + param.Lambda);
                                    
                Jr_L  = (repmat(p0,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(max(Sr_L_ld,Sr2_L_ld),0) + param.Lambda*Jr )/...
                        (param.r + param.delta + param.eta + param.nu + param.Lambda);
 
                Jr2_U = (repmat(p2,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(max(Sr_U_ld,Sr2_U_ld),0) + param.Lambda*Jr )/...
                        (param.r + param.delta + param.eta + param.nu + param.Lambda);
            
                Jr2_L = (repmat(p2,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(max(Sr_L_ld,Sr2_L_ld),0) + param.Lambda*Jr )/...
                        (param.r + param.delta + param.eta + param.nu + param.Lambda);
 
                Ji    =  (- wage + param.rho_y*Jr + param.nu*(1-param.beta)*max(Si,0)   )...
                          ./(param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) +  param.delta + param.eta + param.nu);
                 
                Ji_U = (repmat(p2-param.b_u,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(Si_U_ld,0) + param.Lambda*Ji ...
                         + param.rho_y.*(Sr_U_ld>=Sr2_U_ld).*Jr_U + param.rho_y.*(Sr_U_ld< Sr2_U_ld).*Jr2_U)./ ...  
                       (param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) +  param.delta + param.eta + param.nu + param.Lambda);
                
                
                Ji_L = (repmat(p2-param.b_u,1,state_length + 2) - wage + param.nu*(1-param.beta)*max(Si_L_ld,0) + param.Lambda*Ji ...
                         + param.rho_y.*(Sr_L_ld>=Sr2_L_ld).*Jr_L + param.rho_y.*(Sr_L_ld< Sr2_L_ld).*Jr2_L)./ ...  
                        (param.r + param.rho_y + repmat(gamma_y_min,aux.x_grid*aux.alpha_grid,1) +  param.delta + param.eta + param.nu + param.Lambda);
                 
                Js0 = ( repmat(p0,1,state_length + 2) - wage +  param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji ...
                    + param.nu*(1-param.beta)*max(max(Ss0,Ss1),0) ) ./ ...
                    ( param.r + param.delta + param.eta + param.nu +   param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) );
            
                Js1 = ( repmat(p1,1,state_length + 2) - wage +  (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji ...
                    + param.nu*(1-param.beta)*max(max(Ss0,Ss1),0) ) ./ ...
                    ( param.r + param.delta + param.eta + param.nu +   (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) );

                
                if contract==1
                   %this is s0 and unlocked
                    wage_new= repmat(p0,1,state_length + 2) + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_U ...
                        + param.nu*(1-param.beta)*max(0,max(Ss2_U_ld,max(Ss0_U_ld,Ss1_U_ld))) ...
                        + param.Lambda*Js0 ...
                        - (1-param.beta)*( param.r + param.delta + param.eta + param.nu +   param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss0_U_ld;
                    wage_s0_U_ld = wage_new;
                            
                elseif contract==2
                    %this is s1 and unlocked
                    wage_new = repmat(p1,1,state_length + 2) + (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_U ...
                        + param.nu*(1-param.beta)*max(0,max(Ss2_U_ld,max(Ss0_U_ld,Ss1_U_ld))) ...
                        + param.Lambda*Js1 ...
                        - (1-param.beta)*( param.r + param.delta + param.eta + param.nu +   (param.lambda_0y+param.lambda_1y)*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss1_U_ld;
                    wage_s1_U_ld = wage_new;
                    
                elseif contract==3
                    %this is s2 and unlocked
                    wage_new = repmat(p2,1,state_length + 2) + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_U ...
                        + param.nu*(1-param.beta)*max(0,max(Ss2_U_ld,max(Ss0_U_ld,Ss1_U_ld))) ...
                        + param.Lambda*(Ss1>=Ss0).*Js1 + param.Lambda*(Ss1<Ss0).*Js0 ...
                        - (1-param.beta)*( param.r + param.delta + param.eta + param.nu +   param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss2_U_ld;
                    wage_s2_U_ld = wage_new;
                    
                elseif contract==4
                    %this is s0 and locked
                    wage_new= repmat(p0,1,state_length + 2) + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_L ...
                        + param.nu*(1-param.beta)*max(0,max(Ss2_L_ld,max(Ss0_L_ld,Ss1_L_ld))) ...
                        + param.Lambda*Js0 ...
                        - (1-param.beta)*( param.r + param.delta + param.eta + param.nu +   param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss0_L_ld;
                    wage_s0_L_ld = wage_new;
                             
                elseif contract==5
                     %this is s1 and locked
                     wage_new = repmat(p0,1,state_length + 2) + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_L ...
                        + param.nu*(1-param.beta)*max(0,max(Ss2_L_ld,max(Ss0_L_ld,Ss1_L_ld))) ...
                        + param.Lambda*Js1 ...
                        - (1-param.beta)*( param.r + param.delta + param.eta + param.nu + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss1_L_ld;
                    wage_s1_L_ld = wage_new;
                     
                elseif contract==6
                     %this is s2 and locked
                     wage_new = repmat(p2,1,state_length + 2) + param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1).*Ji_L ...
                        + param.nu*(1-param.beta)*max(0,max(Ss2_L_ld,max(Ss0_L_ld,Ss1_L_ld))) ...
                        + param.Lambda*(Ss1>=Ss0).*Js1 + param.Lambda*(Ss1<Ss0).*Js0 ...
                        - (1-param.beta)*( param.r + param.delta + param.eta + param.nu +   param.lambda_0y*repmat(li_adj,aux.x_grid*aux.alpha_grid,1) +param.Lambda).*Ss2_L_ld;
                     wage_s2_L_ld = wage_new;
                     
                end
            
            wage_discrep = max(max(abs(wage_new - wage) ))
            wage =0.1*wage_new+0.9*wage;
        end
    end
      
end
           

                    

